program Dipintegrator_3D_fftw
  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  !use dipinteg_3D
  !use dipinteg_3D_slice
  !  use igrad3_period 
  use ztrans_mod
  ! use dipinteg_3D_2
  use dipinteg_3d_fftw3
  use triangle
  use igrad1
  use igrad2_2d
  use igrad2_3d
  use igrad1_3d
  use igrad1_2d
  use igrad1_2d_off
  use igrad2_2d_reg
  use igrad3
  use icai1
  use igrad2
  use leakint_2D
  use leakint2
  use leakint
  use dottest
  use igrad3_epst
  use fault_weight
  use solver_smp_mod
  use weight_solver
  use eps_weight
  use model_mask

  ! use triangle1
 
  implicit none
  integer 	                             :: n1, n2, n3, iter,mirror,bounds,slice,esize,stat1,iv,ik,min_niter
  integer                                    ::padlength,it,ix,iy,ir,dist,taper_len,niter,ip,irls_index,i3
  integer                                    ::linear_niter,movie_index,use_wt
  integer                                    ::ref_2,ref_3,irls,slice_width
  integer                                    ::i1,ext_indicator,iteration_counter
  integer                                    ::max_index,tau_cnt,change_cnt
  real                                       :: q,eps_t,eps_h,pi_var,eps_r,wt_iter
  real                                       ::d1,d2,d3,o1,o2,o3,previous_dtau
  real                                       ::res_scale,res_val,last_res,res_val_diff
  real                                       ::prev_tau_val
  complex, dimension (:,:,:),   allocatable  :: data_in
  complex, dimension (:,:,:),   allocatable    ::ztrans,ztrans2
  real, dimension (:,:,:),   allocatable    ::cos_trans
  real,    dimension (:),     allocatable    :: cos_wt,resid,rand_vec,rt_full,ww_bounds,ww_bounds_temp,max_array
  real,    dimension (:),     allocatable    ::corr_prev_tau,isotau, abs_tau
  real,    dimension(:),pointer              ::rt,hh,dtau,tau,tau_1st,tau_2nd,rt_new,rt_temp
  real,    dimension (:,:),     allocatable  ::hh_2D,tau_slice,ref_array,tau_array
  real,    dimension (:,:),     allocatable  ::tau_2D,ww_2D_bounds,tau2D
  real,    dimension (:,:,:),   allocatable  :: data_amp,data_phz,data_real
  real,    dimension (:,:,:),   allocatable  :: data_imag,px,py,px_mirr,px_new,px_dat
  real,    dimension (:,:,:),   allocatable  :: py_mirr,hh_3D
  real,    dimension (:,:,:),   allocatable  :: hh_3D_trun,tau_3D,res_3D,rt_3D
  real,    dimension (:,:,:,:),   allocatable  ::ww_3D,ww_3D_bounds
  !TEMPORY PTERM STUFF
  real,    dimension (:,:), allocatable      ::p_sqr,p_sqr_dtau,p_sqr_dtau_sm,pterm_cor
  real,    dimension(:),pointer              ::rt_adj,pterm_cor_1D,filter,ww,res_div,res_rev,rt_adj2
  real,    dimension(:),allocatable           ::ww_slice
  integer, dimension (2)                :: n, rect
  real,    dimension  (2)   :: dot1,dot2
  real                                 ::upwt,downwt,p_tau_x,p_tau_y,stop_tol
  integer                                ::tau_1,tau_2
  real                                 ::dtau_dx,dtau_dy,shift_var
  real,    dimension (:,:), allocatable      ::px_2D_new,py_2D_new
  real,    dimension (:,:,:),   allocatable  ::px_3D,py_3D
  real,    dimension (:,:,:),   allocatable  ::p_sqr2,thrd_trm
  real,    dimension (:),   allocatable  ::p_sqr2_1D,thrd_trm_1D,thrd_trm_int
  real,    dimension(:), allocatable         ::tau_sample
  real,    dimension(:,:,:), allocatable         ::tau_sample_3D
  ! TEMPORARY VARIABLES
  real,    dimension (:), allocatable        ::dip_diff,dip_integ,px_1D
  real,    dimension (:,:), allocatable      ::dip_integ2D,dip_correction,initial_model_2d
  real,    dimension (:,:), allocatable      ::tau_grad,model_mask_2d
  real,    dimension (:), pointer        ::model_mask_1d,initial_model
  integer                                    ::iz,i,j
  call sep_init ()
  ! call from_history (n1,n2,n3,esize=4)
  !  call from_history ("esize",esize,8) 
  call from_param("eps_t",eps_t,1.)
  call from_param("eps_h",eps_h,1.)
  call from_param("eps_r",eps_r,1.)
  call from_param("mirror",mirror,1) 
  call from_param("bounds",bounds,2)
  call from_param("slice",slice,0)
  call from_param("ref_2",ref_2,1)
  call from_param("ref_3",ref_3,1)
  !  call from_aux ("dipx", n1,n2,n3,esize=4)
  call from_aux ("dipx", n1,n2,n3,esize=4)
  call from_history ("dipx",d1,1.)
  call from_history ("dipx",d2,1.)
  call from_history ("dipx",d3,1.)
  call from_history ("dipx",o1,0.)
  call from_history ("dipx",o2,0.)
  call from_history ("dipx",o3,0.)

  call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  call to_history ("esize",4)
  call to_history ("d1",d1)
  call to_history ("d2",d2)
  call to_history ("d3",d3)
  call to_history ("o1",o1)
  call to_history ("o2",o2)
  call to_history ("o2",o3)

  write(0,*) 'n1,n2,n3',n1,n2,n3
  call from_param("niter",niter,1)
  call from_param("min_niter",min_niter,1)
  call from_param("linear_niter",linear_niter,100)
  call from_param("wt_iter",wt_iter,1.)
  call from_param("irls",irls,0)
  call from_param("stop_tol",stop_tol,.0001)

  !  call igrad2_3d_init(n1,n2,n3,eps_h)
  !  call dot_test (igrad2_3d_lop,100,300,dot1,dot2)


  ! READ IN DATA
slice=14
  select case(slice)
 
  case(14)  ! 2D integration----1 slice at a time but proper regularization
write(0,*) 'here 1'
    allocate(ztrans( n1,n2,1))
     call z_trans(n1,n2,1,eps_t**2,0.,ztrans)

     allocate(cos_trans(n1*2,n2*2,1),px(n1,n2,1))
     call costrans(n1*2,n2*2,1,eps_t**2,0.,cos_trans)


     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call to_history ("d1",   1)
     call to_history ("d2",   1)
     call to_history ("d3",   1)    
     call to_history ("o1",   0.)
     call to_history ("o2",   0.)
     call to_history ("o3",   0.)   
     allocate(dtau(n1*n2*1),tau(n1*n2*1),tau2D(n1,n2))
     allocate(hh_2D(n1,n2),px_new(n1,n2,2),px_dat(n1,n2,1))
     allocate(resid(n1*n2*2))
     allocate( rt( n1*n2*2))
     allocate(tau_grad(n1,n2))
     dtau=0.
     tau=0.
     tau_grad=0.
     px_new=0.
write(0,*) 'here 2'
     do it=1,n3
        call sep_read(px,"dipx")
        !px(1:60,1:,1)=0.
        !px(110:,1:,1)=0.
        px_new(1:,1:,2)=px(1:,1:,1)
        !px_new(1:80,1:,2)=0.
        write(0,*) maxval(px),minval(px),sum(px)/size(px)
        rt=0.
        hh=0.
        tau=0.
        dtau=0.
        do iter=1,niter
           !  allocate( rt( n1*n2))
           rt(1:n1*n2*2)=reshape(px_new,(/size(px_new)/))

!           call dipintegrate_2D_reg (rt,dtau,eps_t,n1,n2,ztrans) 
           call dipintegrate_2D_fftw3 (rt,dtau,eps_t,n1,n2,cos_trans) 


           !     tau=tau+dtau

           ! contraints
!!$           tau2D=reshape(dtau,(/n1,n2/))
!!$           tau2D(50:80,1:)=0.
!!$
!!$           ! tau2D(168,1:)=0.
!!$           dtau=reshape(tau2D,(/n1*n2/))

           tau=tau+dtau
           write(0,*) maxval(px_new)   

           call correct_dip_2D  (tau,px,px_dat,ref_2)

           ! CALCULATE MODEL RESIDUAL
           tau2D=reshape(tau,(/n1,n2/))
           tau_grad=0.
           do i= 1, n1-1 
              do j= 1, n2-1 
                 tau_grad(i,j)= tau_grad(i,j)+( tau2D(i+1,j) - tau2D(i,j)) 
              end do
           end do
           px_new(1:,1:,1)=-eps_t*tau_grad(1:,1:)
           !px_new(1:,1:,1)=0.
           px_new(1:,1:,2)=px_dat(1:,1:,1)
           !px_new(1:80,1:,2)=0.
           write(0,*) maxval(px_new)   
           !  call dipintegrate_3D_slice (rt,hh,eps_t,eps_h,1,n1,n2,ztrans)

           resid=reshape(px_new,(/n1*n2*2/))

           ! contraints
           !tau2D=reshape(px_new,(/n1,n2/))
           !tau2D(1:50,1:)=0.
           !px_new(1:50,1:,1)=0.
           !px_new(160,1:,1)=0.

           write(0,*) 'iter',iter,'residual',dot_product(resid,resid)
           call sep_write (tau,"mod_movie")
           call sep_write (px_new,"res_movie")
        end do

        hh_2D=reshape(tau,(/n1,n2/))


        call sep_write (hh_2D(1:n1,1:n2)) !-sum(hh_2D(1:n1,1:n2))/(n1*n2)) 
     end do

     !DELETE !!!
     do it=1,n1
        hh_2D(it,1:)=it
     end do
     call sep_write (hh_2D(1:n1,1:n2),"junk")
     call to_history ("n1",   n1,"junk")
     call to_history ("n2",   n2,"junk")

     call to_history ("n1",   n1,"mod_movie")
     call to_history ("n2",   n2,"mod_movie")
     call to_history ("n3",   niter,"mod_movie")    
     call to_history ("esize",4,"mod_movie")

     call to_history ("n1",   n1,"res_movie")
     call to_history ("n2",   n2*2,"res_movie")
     call to_history ("n3",   niter,"res_movie")    
     call to_history ("esize",4,"res_movie")

 
  end select


end program Dipintegrator_3D_fftw











