program Dipintegrator_4D
  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  !use dipinteg_3D
  !use dipinteg_3D_slice
  !  use igrad3_period 
  use ztrans_mod_4D
  use dipinteg_4D
  use triangle
  use igrad1
  use igrad2_2d
  use igrad2_3d
  use igrad3
  use icai1
  use igrad2
  use dottest
  use igrad3_epst
  use fault_weight
  use solver_smp_mod
  use weight_solver

  ! use triangle1          

  implicit none
  integer                                    :: n1, n2, n3, iter,mirror,bounds,slice,esize,stat1,iv,ik
  integer                                    ::padlength,it,ix,iy,ir,dist,taper_len,niter,ip
  integer                                    ::linear_niter,movie_index,use_wt
  integer                                    ::ref_2,ref_3,irls,lines,n2_single
  real                                       :: q,eps_t,eps_h,pi_var,eps_r,wt_iter
  real                                       ::res_scale,res_val,last_res
  complex, dimension (:,:,:),   allocatable  :: data_in
  complex, dimension (:,:,:),   allocatable    ::ztrans,ztrans2
  real,    dimension (:),     allocatable    :: cos_wt,resid,rand_vec,rt_full
  real,    dimension(:),pointer              ::rt,hh,dtau,tau,tau_1st,tau_2nd,rt_new
  real,    dimension (:,:),     allocatable  ::hh_2D
  real,    dimension (:,:),     allocatable  ::tau_2D
  real,    dimension (:,:,:),   allocatable  :: data_amp,data_phz,data_real
  real,    dimension (:,:,:),   allocatable  :: data_imag,px,py,px_mirr,px_new,po
  real,    dimension (:,:,:),   allocatable  :: py_mirr,hh_3D
  real,    dimension (:,:,:),   allocatable  :: hh_3D_trun,tau_3D,res_3D,rt_3D,temp1,tau_3Da
  real,    dimension (:,:,:,:),   allocatable  ::ww_3D
  !TEMPORY PTERM STUFF
  real,    dimension (:,:), allocatable      ::p_sqr,p_sqr_dtau,p_sqr_dtau_sm,pterm_cor
  real,    dimension(:),pointer              ::rt_adj,pterm_cor_1D,filter,ww,res_div,res_rev
  real,    dimension(:),allocatable           ::ww_slice
  integer, dimension (2)                :: n, rect
  real,    dimension  (2)   :: dot1,dot2
  real                                 ::upwt,downwt,p_tau_x,p_tau_y
  integer                                ::tau_1,tau_2
  real                                 ::dtau_dx,dtau_dy,shift_var
  real,    dimension (:,:), allocatable      ::px_2D_new,py_2D_new
  real,    dimension (:,:,:),   allocatable  ::px_3D,py_3D
  call sep_init ()
  ! call from_history (n1,n2,n3,esize=4)
  !  call from_history ("esize",esize,8) 
  call from_param("eps_t",eps_t,1.)
  call from_param("eps_h",eps_h,1.)
  call from_param("eps_r",eps_r,1.)
  call from_param("mirror",mirror,1) 
  call from_param("bounds",bounds,2)
  call from_param("slice",slice,0)
  call from_param("ref_2",ref_2,1)
  call from_param("ref_3",ref_3,1)
  call from_aux ("dipx", n1,n2,n3,esize=4)
  write(0,*) 'n1,n2,n3',n1,n2,n3
  call from_param("niter",niter,1)
  call from_param("linear_niter",linear_niter,100)
  call from_param("wt_iter",wt_iter,1.)
  call from_param("irls",irls,0)
  call from_param("lines",lines,1)  ! number of lines

  n2_single=n2/lines

  ! READ IN DATA
  ! 3D full volume integration

  allocate(px(n1,n2,n3),py(n1,n2,n3),po(n1,n2,n3))
  call sep_read(px,"dipx")
  call sep_read(py,"dipy")
  call sep_read(po,"off_dip")
  write(0,*) 'READ IN THE DIPS'

!!$  po=po
!!$  py=py
  !px=0.

  write(0,*) 'eps_t',eps_t,'eps_h',eps_h


  allocate(ztrans(2*lines,2*n2_single,2*n3))
  call z_trans(2*lines,2*n2_single,2*n3,eps_t**2,eps_h**2,ztrans)
  allocate( rt( 3*n2_single*n3*lines),rt_new(3*n2_single*n3*lines))
!!$  rt=0.
!!$  rt(1:n1*n2*n3)=reshape(px,(/size(px)/))
!!$
!!$  deallocate(px)
!!$  rt(n1*n2*n3+1:2*n1*n2*n3)=reshape(py,(/size(py)/))
!!$  deallocate(py)
  allocate(dtau(lines*n2_single*n3),tau(lines*n2_single*n3),tau_3D(n1,n2,n3))

  allocate(tau_3Da(lines,n2_single,n3))


  ww=1.
  use_wt=1

  rt_new=rt
  movie_index=0.

  !  call igrad2_3d_init(n1,n2,n3,1.)
  allocate(temp1(lines,n2_single,n3))

  overslices: do it=1,n1,1  
     rt=0.
     hh=0.
     tau=0.
     dtau=0.

     write(0,*) 'grabbing slice',it,'of',n1,(real(it)/real(n1))*100.,'% complete'



     do ir=1, lines
        temp1(ir,1:n2_single,1:n3)=po(it,1+(ir-1)*n2_single:n2_single+(ir-1)*n2_single,1:)
     end do
     rt(1:n2_single*n3*lines)                       =reshape(temp1(1:,1:,1:),(/n2_single*n3*lines/))

     do ir=1, lines
        temp1(ir,1:n2_single,1:n3)=px(it,1+(ir-1)*n2_single:n2_single+(ir-1)*n2_single,1:)
     end do
     rt(1+n2_single*n3*lines:2*n2_single*n3*lines)  =reshape(temp1(1:,1:,1:),(/n2_single*n3*lines/))

     do ir=1, lines
        temp1(ir,1:n2_single,1:n3)=py(it,1+(ir-1)*n2_single:n2_single+(ir-1)*n2_single,1:)
     end do
     rt(1+2*n2_single*n3*lines:3*n2_single*n3*lines)=reshape(temp1(1:,1:,1:),(/n2_single*n3*lines/))



     rt_new=rt
     res_scale=dot_product(rt_new,rt_new)
     res_scale=1.



     niterloop:  do iter=1,niter



        write(0,*) 'min dip',minval(rt_new)
        call dipintegrate_3D (rt_new,dtau,eps_t,eps_h,lines,n2_single,n3,ztrans) 
        !
        write(0,*) 'maximum dtau',maxval(dtau)
        write(0,*) 'minimum dtau',minval(dtau)

        tau=tau+dtau
        !     write(0,*) maxval(px_new)  



        !        call correct_dip_3D  (tau,rt,rt_new,lines,n2_single,n3,ref_2,ref_3)
        tau_3Da=reshape(tau,(/lines,n2_single,n3/))
        call correct_dip_4D  (tau,tau_3Da,po,px,py,rt_new,n1,n2,n3,n2_single,lines,ref_2,ref_3,it,eps_t,eps_h)

!!$        if (real(iter)/wt_iter-floor(real(iter)/wt_iter)<.01.and.use_wt==1) then
!!$           write(0,*) 'REWEIGHTING'
!!$           !    if (iter<=10) then
!!$           ww=1/(1+rt_new**2/eps_r**2)**2
!!$           ww_3D=reshape(ww,(/n1,n2,n3,2/))
!!$
!!$           res_rev(1:n1*n2*n3)=rt_new(n1*n2*n3+1:2*n1*n2*n3)
!!$           res_rev(n1*n2*n3+1:2*n1*n2*n3)=rt_new(1:n1*n2*n3)
!!$           stat1=igrad2_3d_lop(.true.,.false.,res_div,res_rev)
!!$
!!$
!!$           tau_3D=reshape(tau,(/n1,n2,n3/))
!!$           res_3D=reshape(rt_new(1:n1*n2*n3),(/n1,n2,n3/))
!!$           movie_index=movie_index+1
!!$
!!$           call sep_write (tau_3D(1:,1:,nint(1.*real(n3)/2.)),"mod_movie")
!!$
!!$        end if
!!$        write(0,*) 'unweighted averge abs dip',sum(abs((rt_new)))/(n1*n2*n3)
!!$        rt_new=rt_new*ww
        write(0,*) 'weighted averge abs dip',sum(abs((rt_new)))/(n1*n2*n3)
        write(0,*) 'iter',iter,'residual',dot_product(rt_new,rt_new)
     end do niterloop


     do ir=1, lines
        tau_3D(it,1+(ir-1)*n2_single:n2_single+(ir-1)*n2_single,1:n3)=tau_3Da(ir,1:,1:)
     end do

     !  tau_3D(it,1:,1:)=reshape(tau,(/n2,n3/))


  end do overslices

  call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  call to_history ("esize",4)
  call sep_write (tau_3D) 
!!$
!!$     call sep_write (ww,"wt_out") 
!!$     call to_history ("n1",   n1,"wt_out")
!!$     call to_history ("n2",   n2,"wt_out")
!!$     call to_history ("n3",   n3*2,"wt_out")    
!!$     call to_history ("esize",4,"wt_out")
!!$
!!$     call sep_write (res_div,"res_div") 
!!$     call to_history ("n1",   n1,"res_div")
!!$     call to_history ("n2",   n2,"res_div")
!!$     call to_history ("n3",   n3,"res_div")    
!!$     call to_history ("esize",4,"res_div")
!!$
!!$     call to_history ("n1",   n1,"mod_movie")
!!$     call to_history ("n2",   n2,"mod_movie")
!!$     call to_history ("n3",   movie_index,"mod_movie")    
!!$     call to_history ("esize",4,"mod_movie")
!!$
!!$     call to_history ("n1",   n1,"res_movie")
!!$     call to_history ("n2",   n2,"res_movie")
!!$     call to_history ("n3",   movie_index,"res_movie")    
!!$     call to_history ("esize",4,"res_movie")
!!$
!!$     call to_history ("n1",   n1,"wt_movie")
!!$     call to_history ("n2",   n2,"wt_movie")
!!$     call to_history ("n3",   movie_index,"wt_movie")    
!!$     call to_history ("esize",4,"wt_movie")

  call to_history ("n1",   lines,"resid")
  call to_history ("n2",   n2_single,"resid")
  call to_history ("n3",   n3,"resid")    
  call to_history ("esize",4,"resid")
  call sep_write (rt_new(1+2*n2_single*n3*lines:3*n2_single*n3*lines),"resid") 

!!$     call to_history ("n1",   n1,"res_cube_movie")
!!$     call to_history ("n2",   n2,"res_cube_movie")
!!$     call to_history ("n3",   n3*2,"res_cube_movie")
!!$     call to_history ("n4", movie_index  ,"res_cube_movie")
!!$     call to_history ("esize",4,"res_cube_movie")

  !
  call sep_close()
  call exit (0)





end program Dipintegrator_4D











