program Dip_res_2d !
  ! calculate residual of dip
  !
  use sep
  use lint1
  use lint1_jesse
  use sorting_mod
  use lint2

  implicit none
  integer 	                          :: n1, n2, n3, i1,i2,i3,stat1,diff,ip,it,data_out_index,subsam, shift_floor, shift_ceil, useinwt,n1_long,min_shift,counter,max_shift,win
  integer ::mm_min, mm_max, mm_sz,n1_aux,n1_out,ref_2,ref_3,strt,fnsh
  integer :: is_allocate,ivar
  real :: d1,d2,d3,o1,o2,o3,o1_aux,mean_val
  real,   dimension(:,:), allocatable,target    :: shifted_outputs,out
  real,    dimension (:,:),   allocatable :: data_in,data_out,time_cube,outwt,inwt,dip
  real, save, pointer, dimension(:)         ::lint_in, lint_out,shift_vec,shifted_test
  real,dimension(:),allocatable         ::mm_interp,data_in_1d,path_dd
  real, save, dimension(:),pointer                        ::coord
  real                                      ::shift_var,iprl, diffrl,shift_diff,upwt,dwnwt,max_move,min_move,range_move,var
    real, pointer, dimension(:,:)       ::new_path_xy
    real, pointer, dimension(:)       ::new_point
  logical :: flatten
  call sep_init ()
  call from_history (n1,n2,n3, esize = 4)

  call to_history ("esize",4)

  call from_history ("d1",d1,1.) ; call from_history ("o1",o1,0.)
  call from_history ("d2",d2,1.) ; call from_history ("o2",o2,0.)
  call from_history ("d3",d3,1.) ; call from_history ("o3",o3,0.)
  call from_param("win",win,20)





  allocate (data_in(n1,n2),data_in_1d(n1*n2),dip(n1,n2),out(n1,n2))  !,inwt(n1,n2,n3)                                ! read data

  ! ; data = data / maxval (cabs (data)) ! normalize
  ! inwt=0.
  !  if (useinwt==0.) then
  !   inwt=1.
  !  else 
  !    call sreed("inwt", inwt,4*n1*n2*n3)

  !  endif



  write(0,*) 'n1/n2/n3',n1,n2,n3
  call sreed("in", data_in,4*n1*n2)
  call sreed("dip", dip,4*n1*n2)
  out=0.
 data_in_1d=reshape(data_in,(/n1*n2/))
  allocate(new_path_xy(1,2),path_dd(1),new_point(1))

  do i2=1,n2-1
     do i1=1,n1      

!!$        strt=max(i2-win,1)
!!$        fnsh=min(i2+win,n2)
!!$
!!$        ! CALCUALATE MEAN
!!$        mean_val=sum(data_in(i1,strt:fnsh))/(fnsh-strt+1)
!!$        var=0.
!!$
!!$        !CALCULATE VARIANCE
!!$        do ivar=strt, fnsh
!!$
!!$           var=var+abs(data_in(i1,ivar)-mean_val)
!!$        end do
!!$
!!$        out(i1,i2)= var**.5


        new_path_xy(1,1)=real(i1)+dip(i1,i2) ; new_path_xy(1,2)=real(i2)
        ! INITIALIZE BILINEAR INTERPOLATOR
    !    call lint2_init(n1,n2,1.,1.,1.,1.,new_path_xy)

new_point(1)=real(i1)+dip(i1,i2)
call lint1_init(1.,1.,new_point)

  !      stat1=lint2_lop(.false.,.false.,data_in_1d,path_dd)
    stat1=lint1_lop(.false.,.false.,data_in_1d,path_dd)
        out(i1,i2)=path_dd(1)-data_in(i1,i2)

     end do
  end do


  call to_history ("n1",   n1)
  call to_history ("n2",n2) 
  call to_history ("n3",1) 

  call sep_write(out)	



  call sep_close()
  call exit (0)
end program Dip_res_2d














