program Dipintegrator_3D_2
  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  !use dipinteg_3D
  !use dipinteg_3D_slice
  !  use igrad3_period 
  use ztrans_mod
  use dipinteg_3D_2
  use triangle
  use igrad1
  use igrad2_2d
  use igrad2_3d
  use igrad1_3d
  use igrad1_2d
  use igrad3
  use icai1
  use igrad2
  use leakint_2D
  use leakint2
  use leakint
  use dottest
  use igrad3_epst
  use fault_weight
  use solver_smp_mod
  use weight_solver

  ! use triangle1

  implicit none
  integer 	                             :: n1, n2, n3, iter,mirror,bounds,slice,esize,stat1,iv,ik
  integer                                    ::padlength,it,ix,iy,ir,dist,taper_len,niter,ip
  integer                                    ::linear_niter,movie_index,use_wt
  integer                                    ::ref_2,ref_3,irls,slice_width
  integer                                    ::i1,ext_indicator,iteration_counter
  real                                       :: q,eps_t,eps_h,pi_var,eps_r,wt_iter
  real                                       ::d1,d2,d3,o1,o2,o3,previous_dtau
  real                                       ::res_scale,res_val,last_res,res_val_diff
  complex, dimension (:,:,:),   allocatable  :: data_in
  complex, dimension (:,:,:),   allocatable    ::ztrans,ztrans2
  real,    dimension (:),     allocatable    :: cos_wt,resid,rand_vec,rt_full
  real,    dimension(:),pointer              ::rt,hh,dtau,tau,tau_1st,tau_2nd,rt_new,px,py
  real,    dimension (:,:),     allocatable  ::hh_2D,tau_slice
  real,    dimension (:,:),     allocatable  ::tau_2D
  real,    dimension (:,:,:),   allocatable  :: data_amp,data_phz,data_real
  real,    dimension (:,:,:),   allocatable  :: data_imag,px_mirr,px_new
  real,    dimension (:,:,:),   allocatable  :: py_mirr,hh_3D
  real,    dimension (:,:,:),   allocatable  :: hh_3D_trun,tau_3D,res_3D,rt_3D
  real,    dimension (:,:,:,:),   allocatable  ::ww_3D
  !TEMPORY PTERM STUFF
  real,    dimension (:,:), allocatable      ::p_sqr,p_sqr_dtau,p_sqr_dtau_sm,pterm_cor
  real,    dimension(:),pointer              ::rt_adj,pterm_cor_1D,filter,ww,res_div,res_rev,rt_adj2
  real,    dimension(:),allocatable           ::ww_slice
  integer, dimension (2)                :: n, rect
  real,    dimension  (2)   :: dot1,dot2
  real                                 ::upwt,downwt,p_tau_x,p_tau_y,stop_tol
  integer                                ::tau_1,tau_2
  real                                 ::dtau_dx,dtau_dy,shift_var
  real,    dimension (:,:), allocatable      ::px_2D_new,py_2D_new
  real,    dimension (:,:,:),   allocatable  ::px_3D,py_3D
  real,    dimension (:,:,:),   allocatable  ::p_sqr2,thrd_trm
  real,    dimension (:),   allocatable  ::p_sqr2_1D,thrd_trm_1D,thrd_trm_int
  real,    dimension(:), allocatable         ::tau_sample
  real,    dimension(:,:,:), allocatable         ::tau_sample_3D
  ! TEMPORARY VARIABLES
  real,    dimension (:), allocatable        ::dip_diff,dip_integ,px_1D
  real,    dimension (:,:), allocatable      ::dip_integ2D,dip_correction
  integer                                    ::iz,iv 
  call sep_init ()
  ! call from_history (n1,n2,n3,esize=4)
  !  call from_history ("esize",esize,8) 
  call from_param("eps_t",eps_t,1.)
  call from_param("eps_h",eps_h,1.)
  call from_param("eps_r",eps_r,1.)
  call from_param("mirror",mirror,1) 
  call from_param("bounds",bounds,2)
  call from_param("slice",slice,0)
  call from_param("ref_2",ref_2,1)
  call from_param("ref_3",ref_3,1)
  !  call from_aux ("dipx", n1,n2,n3,esize=4)
  call from_aux ("dipx", n1,n2,n3,esize=4)
  call from_history ("dipx",d1,1.)
  call from_history ("dipx",d2,1.)
  call from_history ("dipx",d3,1.)
  call from_history ("dipx",o1,0.)
  call from_history ("dipx",o2,0.)
  call from_history ("dipx",o3,0.)


  write(0,*) 'n1,n2,n3',n1,n2,n3
  call from_param("niter",niter,1)
  call from_param("linear_niter",linear_niter,100)
  call from_param("wt_iter",wt_iter,1.)
  call from_param("irls",irls,0)
  call from_param("stop_tol",stop_tol,.0001)

  allocate(ztrans(1,2*n1,2*n2))
  call z_trans(1,2*n1,2*n2,0.,eps_h**2,ztrans)

  allocate( rt( n1*n2*2),tau(n1*n2))
  allocate(px(n1*n2),py(n1*n2))
  allocate(rt_adj2(n1*n2)) !,resid(n2*n3*2))

  write(0,*) 'after major allocations!!!!'


  movie_index=0

  iteration_counter=0

  sliceloop2: do it=1,n3,1 


     write(0,*) 'grabbing slice',it,'of',n3,(real(it)/real(n3))*100.,'% complete'
     rt=0.
     hh=0.
     call sep_read(rt(1:n1*n2),"dipx")
     call sep_read(rt(n1*n2+1:n1*n2*2),"dipy")


     if (exist_file("wt_in")) then
        write(0,*) 'READING IN WEIGHT'
        ww(1:n1*n2)        =reshape(ww_3D(it,1:,1:,1),(/n1*n2/))
        ww(n1*n2+1:2*n1*n2)=reshape(ww_3D(it,1:,1:,1),(/n1*n2/))  
        rt_new=rt_new*ww
     end if


     call igrad2_init(n1,n2)

     rt(n1*n2+1:)=rt(n1*n2+1:)*(eps_h**2)       ! APPLY EPSILLON

     stat1=igrad2_lop(.true.,.false.,rt_adj2 , rt)  ! APPLY DIVERGENCE
     call dipintegrate_timeslice_full (rt_adj2,tau,n1,n2,ztrans,eps_h)
     call sep_write(tau) 




  end do sliceloop2


  write(0,*) 'EPS_H OUT',eps_h


  call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)     
  call to_history ("esize",4)
  call to_history ("d1",   d1)
  call to_history ("d2",   d2)
  call to_history ("d3",   d3)     
  call to_history ("o1",   o1)
  call to_history ("o2",   o2)
  call to_history ("o3",   o3)     



end program Dipintegrator_3D_2











