program Dipintegrator_3D_2
  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  !use dipinteg_3D
  !use dipinteg_3D_slice
  !  use igrad3_period 
  use ztrans_mod
  use dipinteg_3D_2
  use triangle
  use igrad1
  use igrad2_2d
  use igrad2_3d
  use igrad1_3d
  use igrad1_2d
  use igrad1_2d_off
  use igrad2_2d_reg
  use igrad3
  use icai1
  use igrad2
  use leakint_2D
  use leakint2
  use leakint
  use dottest
  use igrad3_epst
  use fault_weight
  use solver_smp_mod 
  use weight_solver
  use eps_weight
 ! use model_mask

  ! use triangle1

  implicit none
  integer 	                             :: n1, n2, n3, iter,mirror,bounds,slice,esize,stat1,iv,ik,min_niter
  integer                                    ::padlength,it,ix,iy,ir,dist,taper_len,niter,ip,irls_index,i3
  integer                                    ::linear_niter,movie_index,use_wt
  integer                                    ::ref_2,ref_3,irls,slice_width
  integer                                    ::i1,ext_indicator,iteration_counter
  integer                                    ::max_index,tau_cnt,change_cnt
  real                                       :: q,eps_t,eps_h,pi_var,eps_r,wt_iter
  real                                       ::d1,d2,d3,o1,o2,o3,previous_dtau
  real                                       ::res_scale,res_val,last_res,res_val_diff
  real                                       ::prev_tau_val
  complex, dimension (:,:,:),   allocatable  :: data_in
  complex, dimension (:,:,:),   allocatable    ::ztrans,ztrans2
  real, dimension (:,:,:),   allocatable    ::cos_trans
  real,    dimension (:),     allocatable    :: cos_wt,resid,rand_vec,rt_full,ww_bounds,ww_bounds_temp,max_array
  real,    dimension (:),     allocatable    ::corr_prev_tau,isotau, abs_tau
  real,    dimension(:),pointer              ::rt,hh,dtau,tau,tau_1st,tau_2nd,rt_new,rt_temp
  real,    dimension (:,:),     allocatable  ::hh_2D,tau_slice,ref_array,tau_array
  real,    dimension (:,:),     allocatable  ::tau_2D,ww_2D_bounds,tau2D
  real,    dimension (:,:,:),   allocatable  :: data_amp,data_phz,data_real
  real,    dimension (:,:,:),   allocatable  :: data_imag,px,py,px_mirr,px_new,px_dat
  real,    dimension (:,:,:),   allocatable  :: py_mirr,hh_3D
  real,    dimension (:,:,:),   allocatable  :: hh_3D_trun,tau_3D,res_3D,rt_3D
  real,    dimension (:,:,:,:),   allocatable  ::ww_3D,ww_3D_bounds
  !TEMPORY PTERM STUFF
  real,    dimension (:,:), allocatable      ::p_sqr,p_sqr_dtau,p_sqr_dtau_sm,pterm_cor
  real,    dimension(:),pointer              ::rt_adj,pterm_cor_1D,filter,ww,res_div,res_rev,rt_adj2
  real,    dimension(:),allocatable           ::ww_slice
  integer, dimension (2)                :: n, rect
  real,    dimension  (2)   :: dot1,dot2
  real                                 ::upwt,downwt,p_tau_x,p_tau_y,stop_tol
  integer                                ::tau_1,tau_2
  real                                 ::dtau_dx,dtau_dy,shift_var
  real,    dimension (:,:), allocatable      ::px_2D_new,py_2D_new
  real,    dimension (:,:,:),   allocatable  ::px_3D,py_3D
  real,    dimension (:,:,:),   allocatable  ::p_sqr2,thrd_trm
  real,    dimension (:),   allocatable  ::p_sqr2_1D,thrd_trm_1D,thrd_trm_int
  real,    dimension(:), allocatable         ::tau_sample
  real,    dimension(:,:,:), allocatable         ::tau_sample_3D
  ! TEMPORARY VARIABLES
  real,    dimension (:), allocatable        ::dip_diff,dip_integ,px_1D
  real,    dimension (:,:), allocatable      ::dip_integ2D,dip_correction,initial_model_2d
  real,    dimension (:,:), allocatable      ::tau_grad,model_mask_2d
  real,    dimension (:), pointer        ::model_mask_1d,initial_model
  integer                                    ::iz,i,j
  call sep_init ()
  ! call from_history (n1,n2,n3,esize=4)
  !  call from_history ("esize",esize,8) 
  call from_param("eps_t",eps_t,1.)
  call from_param("eps_h",eps_h,1.)
  call from_param("eps_r",eps_r,1.)
  call from_param("mirror",mirror,1) 
  call from_param("bounds",bounds,2)
  call from_param("slice",slice,0)
  call from_param("ref_2",ref_2,1)
  call from_param("ref_3",ref_3,1)
  !  call from_aux ("dipx", n1,n2,n3,esize=4)
  call from_aux ("dipx", n1,n2,n3,esize=4)
  call from_history ("dipx",d1,1.)
  call from_history ("dipx",d2,1.)
  call from_history ("dipx",d3,1.)
  call from_history ("dipx",o1,0.)
  call from_history ("dipx",o2,0.)
  call from_history ("dipx",o3,0.)

  call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  call to_history ("esize",4)
  call to_history ("d1",d1)
  call to_history ("d2",d2)
  call to_history ("d3",d3)
  call to_history ("o1",o1)
  call to_history ("o2",o2)
  call to_history ("o2",o3)

  write(0,*) 'n1,n2,n3',n1,n2,n3
  call from_param("niter",niter,1)
  call from_param("min_niter",min_niter,1)
  call from_param("linear_niter",linear_niter,100)
  call from_param("wt_iter",wt_iter,1.)
  call from_param("irls",irls,0)
  call from_param("stop_tol",stop_tol,.0001)

  !  call igrad2_3d_init(n1,n2,n3,eps_h)
  !  call dot_test (igrad2_3d_lop,100,300,dot1,dot2)


  ! READ IN DATA
  select case(slice)
  case(0) 
     ! 3D full volume integration
     if (n3>1.and.n2>1.and.n1>1) then
        allocate(px(n1,n2,n3),py(n1,n2,n3))
        call sep_read(px,"dipx")
        call sep_read(py,"dipy")
        write(0,*) 'READ IN THE DIPS'
!!$        px(1:,12:27,24)=1. ! DELETE ME!!!!!!
        !  px(1:,23,25)=-20. ! DELETE ME!!!!!!

        !  pz=1. ! set to 1's
        ! allocate(ztrans(n1,2*n2,2*n3))


        ! call z_trans(n1,2*n2,2*n3,eps_t,eps_h,ztrans)

        ! FLATTEN TIME SLICE
!!$     else if (n3==1.and.n1>1.and.n2>1) then! 2D integration----1 time slice at a time
!!$        allocate(data_in(n1,n2,1),px(n1,n2,1),py(n1,n2,1))
!!$        bounds=4
!!$        call sep_read (data_in) 
!!$        px=real(data_in)  ! x direction dip
!!$        py=aimag(data_in)  ! y direction dip
!!$        call z_trans(1,2*n2,2*n3,1.,1.,ztrans)


        ! 2D VERTICAL SECTION
     else if (n3==1.and.n1>1.and.n2>1) then
        write(0,*) 'THIS IS A 2D SECTION'
        !        bounds=2
        !  allocate(ztrans(n1,2*n2,n3),px(n1,n2,n3))
        ! call z_trans(n1,2*n2,1,eps_t,0.,ztrans)

!!$
!!$        call sep_write (real(ztrans),"test")
!!$        call to_history ("n1",   n1,"test")
!!$        call to_history ("n2",   n2*2,"test")
        !     stop
     else 
        write(0,*) 'error: do you have the right dimensions?'
        call exit(0)
     end if

     ! IF BIG VOLUME AND WANT TO DO ONE SLICE AT A TIME
  case(1) ! IF BIG VOLUME AND WANT TO DO ONE SLICE AT A TIME
     allocate(data_in(n1,n2,1),px(n1,n2,1),py(n1,n2,1))
     bounds=5
     ! allocate(ztrans(2*n1,2*n2,1))
     ! call z_trans(2*n1,2*n2,1,1.,0.,ztrans)

  case(2) ! 3D GATHER FLATTENING
  case(3) !other

  end select






  ! write(0,*) 'about to make mirrors'
  ! MAKE MIRRORS

  ! allocate(pz_mirr(n1,n2*2,n3*2))
  ! pz_mirr=0.


  !  rt(1:n1*n2*2*n3*2)=reshape(pz_mirr,(/size(pz_mirr)/))
  !  deallocate(pz_mirr)

  select case(bounds)
  case(0)
     allocate(ztrans(n1,2*n2,2*n3))
     call z_trans(n1,2*n2,2*n3,eps_t,eps_h,ztrans)
     allocate( rt( n1*n2*n3*2),rt_new(n1*n2*n3*2))
     rt=0.
     rt(1:n1*n2*n3)=reshape(px,(/size(px)/))

     deallocate(px)
     rt(n1*n2*n3+1:2*n1*n2*n3)=reshape(py,(/size(py)/))
     deallocate(py)
     allocate(dtau(n1*n2*n3),tau(n1*n2*n3),ww(n1*n2*n3*2),tau_3D(n1,n2,n3),res_3D(n1,n2,n3))

     allocate(res_div(n1*n2*n3),res_rev(n1*n2*n3*2),ww_3D(n1,n2,n3,2))
     allocate(rt_3D(n1,n2,2*n3))
     allocate(ww_3D_bounds(n1,n2,n3,2),ww_bounds(n1*n2*n3*2))


     tau=0.

     ! CREATE WEIGHT BOUNDS
     ww_3D_bounds=0.
     ww_3D_bounds(1:,1:n2-1,1:n3-1,1)=1.
     ww_3D_bounds(1:,1:n2-1,1:n3-1,2)=1.

     ww_bounds=reshape(ww_3D_bounds,(/n1*n2*n3*2/))


!!$
!!$     tau_3D=reshape(tau,(/n1,n2,n3/))
!!$     do iv=1,n1
!!$        do ik=1,15
!!$           tau_3D(iv,ik+11,24)=ik ! DELETE ME!!!!!!
!!$        enddo
!!$     enddo
!!$     tau=reshape(tau_3D,(/n1*n2*n3/))
!!$

     dtau=0.
     ww=1.
     use_wt=1
     if (exist_file("wt_in")) then
        call sreed("wt_in",ww,4*n1*n2*n3*2)
        write(0,*) 'READ IN WEIGHT'
        use_wt=1
        rt=rt*ww
     end if
     rt_new=rt
     movie_index=0.
     irls_index=0
     res_scale=max(1.,sqrt(dot_product(rt_new,rt_new)))
     res_val=1. !res_scale

     call igrad2_3d_init(n1,n2,n3,1.)
     do iter=1,niter


        ! DELETE SECTION
!!$        if (iter>10) then
!!$           rt_3D=reshape(rt_new,(/n1,n2,n3*2/))
!!$           rt_3D(1:,23:26,25)=-20. ! DELETE ME!!!!!!           rt_new=reshape(rt_3D,(/n1*n2*n3*2/))
!!$           rt_new=reshape(rt_3D,(/n1*n2*n3*2/))
!!$           where (ww_3D<.5) ww_3D=0.
!!$ww_3D(1:,23,1:,1)=0.
!!$    ww_3D(1:,1:,1:,2)=ww_3D(1:,1:,1:,1)
!!$           ww_3D(1:,23,24,1)=1. ! DELETE ME!!!!!!
!!$           ww=reshape(ww_3D,(/n1*n2*n3*2/))
!!$           rt_new=rt_new*ww
!!$        end if
        write(0,*) 'min dip',minval(rt_new)
        call dipintegrate_3D (rt_new,dtau,eps_t,eps_h,n1,n2,n3,ztrans) 
!!$   if  (iter<=10) tau=0.
        write(0,*) 'maximum dtau',maxval(dtau)
        write(0,*) 'minimum dtau',minval(dtau)

        tau=tau+dtau
        !   write(0,*) maxval(px_new)  



        call correct_dip_3D  (tau,rt,rt_new,n1,n2,n3,ref_2,ref_3)
        ! if (real(iter)/wt_iter-floor(real(iter)/wt_iter)<.01.and.use_wt==1) then 
        res_val_diff=res_val-sqrt(dot_product(rt_new,rt_new))/res_scale
        if (abs(res_val_diff)<stop_tol.and.iter>1.and.irls==1) then
           irls_index=irls_index+1
           write(0,*) 'REWEIGHTING',irls_index
           !    if (iter<=10) then

           if (real(iter)/200-floor(real(iter)/200)<.00001) eps_r=eps_r*.8
           ! STANDARD WEIGHT
           ww=1/(1+rt_new**2/eps_r**2)**2
           ww=ww*ww_bounds
           ! ww=1/(1+rt_new**2/eps_r**2)
           ww_3D=reshape(ww,(/n1,n2,n3,2/))

           ! ANOTHER WEIGHT
!!$           res_div=rt_new(1:n1*n2*n3)*rt_new(n1*n2*n3+1:n1*n2*n3*2)
!!$           ww(1:n1*n2*n3)=1/(1+rt_new**2/eps_r**2)**2
!!$           ww(n1*n2*n3+1:n1*n2*n3*2)=ww(1:n1*n2*n3)

           !   end if
!!$
!!$           ww_3D(1:,23,24)=.1*iter ! DELETE ME!!!!!!
!!$           ww=reshape(ww_3D,(/n1*n2*n3*2/))

           ! another weight 
           !           res_rev(1:n1*n2*n3)=rt_new(n1*n2*n3+1:2*n1*n2*n3)
           !           res_rev(n1*n2*n3+1:2*n1*n2*n3)=rt_new(1:n1*n2*n3)
           !           stat1=igrad2_3d_lop(.true.,.false.,res_div,res_rev)

!!$           ww(1:n1*n2*n3)=1/(1+res_div**2/eps_r**2)**2
!!$           ww(n1*n2*n3+1:n1*n2*n3*2)=ww(1:n1*n2*n3)

           tau_3D=reshape(tau,(/n1,n2,n3/))
           res_3D=reshape(rt_new(1:n1*n2*n3),(/n1,n2,n3/))
           movie_index=movie_index+1

           !  call sep_write (tau_3D(1:,1:,nint(1.*real(n3)/2.)),"mod_movie")
!!$      call sep_write (tau_3D(1:,1:,97),"mod_movie") 
           !     call sep_write (res_3D(1:,1:,nint(5.*real(n3)/6.)),"res_movie")
           call sep_write (res_3D(1:,1:,nint(1.*real(n3)/2.)),"res_movie")
           !call sep_write (ww_3D(1:,1:,nint(1.*real(n3)/2.),1),"wt_movie")
           call sep_write (ww_3D(50,1:,1:,1:),"wt_movie")
           !        call sep_write (rt_new,"res_cube_movie")
           !   tau=0.
        end if
        res_val=sqrt(dot_product(rt_new,rt_new))/res_scale
        write(0,*) 'unweighted averge abs dip',sum(abs((rt_new)))/(n1*n2*n3)
        !     ww(1:n1*n2*n3)=1. !!!!!! DELETE  6/20/05   !!!!!!!
        rt_new=rt_new*ww
        write(0,*) 'weighted averge abs dip',sum(abs((rt_new)))/(n1*n2*n3)
        write(0,*) 'iter',iter,'residual',dot_product(rt_new,rt_new)
     end do

     write(0,*) 'EPS_H OUT',eps_h

     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call sep_write (tau) 

     call sep_write (ww,"wt_out") 
     call to_history ("n1",   n1,"wt_out")
     call to_history ("n2",   n2,"wt_out")
     call to_history ("n3",   n3*2,"wt_out")    
     call to_history ("esize",4,"wt_out")

!!$     call sep_write (res_div,"res_div") 
!!$     call to_history ("n1",   n1,"res_div")
!!$     call to_history ("n2",   n2,"res_div")
!!$     call to_history ("n3",   n3,"res_div")    
!!$     call to_history ("esize",4,"res_div")

     call to_history ("n1",   n1,"mod_movie")
     call to_history ("n2",   n2,"mod_movie")
     call to_history ("n3",   movie_index,"mod_movie")    
     call to_history ("esize",4,"mod_movie")

     call to_history ("n1",   n1,"res_movie")
     call to_history ("n2",   n2,"res_movie")
     call to_history ("n3",   movie_index,"res_movie")    
     call to_history ("esize",4,"res_movie")

     call to_history ("n1",   n2,"wt_movie")
     call to_history ("n2",   n3*2,"wt_movie")
     call to_history ("n3",   movie_index,"wt_movie")    
     call to_history ("esize",4,"wt_movie")

     call to_history ("n1",   n1,"resid")
     call to_history ("n2",   n2,"resid")
     call to_history ("n3",   n3*2,"resid")    
     call to_history ("esize",4,"resid")
     call sep_write (rt_new,"resid") 

!!$     call to_history ("n1",   n1,"res_cube_movie")
!!$     call to_history ("n2",   n2,"res_cube_movie")
!!$     call to_history ("n3",   n3*2,"res_cube_movie")
!!$     call to_history ("n4", movie_index  ,"res_cube_movie")
!!$     call to_history ("esize",4,"res_cube_movie")

     !
     call sep_close()
     call exit (0)
!!$  case(1) ! 3D using conjagate gradients
!!$     !    allocate(ztrans(n1,2*n2,2*n3))
!!$     !    call z_trans(n1,2*n2,2*n3,eps_t,eps_h,ztrans)
!!$     allocate( rt( n1*n2*n3*2),rt_new(n1*n2*n3*2))
!!$     rt=0.
!!$     rt(1:n1*n2*n3)=reshape(px,(/size(px)/))
!!$     deallocate(px)
!!$     rt(n1*n2*n3+1:2*n1*n2*n3)=reshape(py,(/size(py)/))
!!$     deallocate(py)
!!$     allocate(dtau(n1*n2*n3),tau(n1*n2*n3),ww(n1*n2*n3*2),tau_3D(n1,n2,n3),res_3D(n1,n2,n3))
!!$     if (exist_file("wt_in")) then
!!$        call sreed("wt_in",ww,4*n1*n2*n3*2)
!!$        write(0,*) 'READ IN WEIGHT'
!!$        use_wt=0
!!$        rt=rt*ww
!!$     end if
!!$
!!$     rt_new=rt
!!$     tau=0.
!!$     dtau=0.
!!$     ww=1.
!!$     movie_index=0.
!!$     !     call igrad2_2d_init(n1,n2)
!!$     call igrad2_3d_init(n1,n2,n3,1.)
!!$     !    call igrad3_init(n1,n2,n3)
!!$     !    call dot_test (igrad3_lop,100,300,dot1,dot2)
!!$
!!$     !     call dot_test (igrad2_3d_lop,100,200,dot1,dot2)
!!$
!!$
!!$     do iter=1,niter
!!$        call fault_w_init(ww)
!!$        !  call dipintegrate_3D (rt_new,dtau,eps_t,eps_h,n1,n2,n3,ztrans) 
!!$        call solver_smp(dtau, rt_new,igrad2_3d_lop,cgstep,linear_niter,verb=.true.,Wop=fault_w_oper)
!!$        !call solver(igrad2_3d_lop,solver_smp,dtau,rt_new,linear_niter,3,4,ww)
!!$        call cgstep_close ()
!!$        tau=tau+dtau
!!$        write(0,*) maxval(px_new)  
!!$
!!$        call correct_dip_3D  (tau,rt,rt_new,n1,n2,n3,ref_2,ref_3)
!!$        !   if (real(iter)/wt_iter-floor(real(iter)/wt_iter)<.01) ww=1/(1+rt_new**2/eps_r**2)**2
!!$        if (real(iter)/wt_iter-floor(real(iter)/wt_iter)<.01) then
!!$           ww=1/(1+rt_new**2/eps_r**2)**2
!!$           tau_3D=reshape(tau,(/n1,n2,n3/))
!!$           res_3D=reshape(rt_new(1:n1*n2*n3),(/n1,n2,n3/))
!!$           movie_index=movie_index+1           
!!$           call sep_write (tau_3D(1:,1:,nint(5.*real(n3)/6.)),"mod_movie")
!!$           call sep_write (res_3D(1:,1:,nint(5.*real(n3)/6.)),"res_movie")
!!$           tau=0.
!!$        end if
!!$        !  rt_new=rt_new*ww
!!$        write(0,*) 'iter',iter,'residual',dot_product(rt_new,rt_new)
!!$     end do
!!$
!!$     call to_history ("n1",   n1)
!!$     call to_history ("n2",   n2)
!!$     call to_history ("n3",   n3)    
!!$     call to_history ("esize",4)
!!$     call sep_write (tau) 
!!$
!!$     call sep_write (ww,"wt_out") 
!!$     call to_history ("n1",   n1,"wt_out")
!!$     call to_history ("n2",   n2,"wt_out")
!!$     call to_history ("n3",   n3*2,"wt_out")    
!!$     call to_history ("esize",4,"wt_out")
!!$
!!$     call to_history ("n1",   n1,"mod_movie")
!!$     call to_history ("n2",   n2,"mod_movie")
!!$     call to_history ("n3",   movie_index,"mod_movie")    
!!$     call to_history ("esize",4,"mod_movie")
!!$
!!$     call to_history ("n1",   n1,"res_movie")
!!$     call to_history ("n2",   n2,"res_movie")
!!$     call to_history ("n3",   movie_index,"res_movie")    
!!$     call to_history ("esize",4,"res_movie")
!!$
!!$     call to_history ("n1",   n1,"resid")
!!$     call to_history ("n2",   n2,"resid")
!!$     call to_history ("n3",   n3*2,"resid")    
!!$     call to_history ("esize",4,"resid")
!!$     call sep_write (rt_new,"resid") 
!!$     !
!!$     call sep_close()
!!$     call exit (0)




  case(2)  ! 2D integration----1 slice at a time

     allocate(ztrans(n1,2*n2,1),px(n1,n2,1))
     call z_trans(n1,2*n2,1,eps_t,0.,ztrans)


     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call to_history ("d1",   1)
     call to_history ("d2",   1)
     call to_history ("d3",   1)    
     call to_history ("o1",   0.)
     call to_history ("o2",   0.)
     call to_history ("o3",   0.)   
     allocate(dtau(n1*n2*1),tau(n1*n2*1),tau2D(n1,n2))
     allocate(hh_2D(n1,n2),px_new(n1,n2,1))
     allocate(resid(n1*n2*1))
     allocate( rt( n1*n2))
     dtau=0.
     tau=0.

     do it=1,n3
        call sep_read(px,"dipx")
        px_new=px
        write(0,*) maxval(px),minval(px),sum(px)/size(px)
        rt=0.
        hh=0.
        tau=0.
        dtau=0.
        do iter=1,niter
           !  allocate( rt( n1*n2))
           rt(1:n1*n2)=reshape(px_new,(/size(px)/))

           call dipintegrate_2D (rt,dtau,eps_t,n1,n2,ztrans) 

           tau=tau+dtau

           ! contraints
           !   tau2D=reshape(tau,(/n1,n2/))
           !   tau2D(1:50,1:)=0.
           !tau2D(160,1:)=0.
           !   tau=reshape(tau2D,(/n1*n2/))

           write(0,*) maxval(px_new)   
           call correct_dip_2D  (tau,px,px_new,ref_2)
           write(0,*) maxval(px_new)   
           !  call dipintegrate_3D_slice (rt,hh,eps_t,eps_h,1,n1,n2,ztrans)

           resid=reshape(px_new,(/n1*n2*1/))

           ! contraints
           !tau2D=reshape(px_new,(/n1,n2/))
           !tau2D(1:50,1:)=0.
           !px_new(1:50,1:,1)=0.
           !px_new(160,1:,1)=0.

           write(0,*) 'iter',iter,'residual',dot_product(resid,resid)
           call sep_write (tau,"mod_movie")
        end do

        hh_2D=reshape(tau,(/n1,n2/))


        call sep_write (hh_2D(1:n1,1:n2)) !-sum(hh_2D(1:n1,1:n2))/(n1*n2)) 
     end do

     !DELETE !!!
     do it=1,n1
        hh_2D(it,1:)=it
     end do
!!$     call sep_write (hh_2D(1:n1,1:n2),"junk")
!!$     call to_history ("n1",   n1,"junk")
!!$     call to_history ("n2",   n2,"junk")

     call to_history ("n1",   n1,"mod_movie")
     call to_history ("n2",   n2,"mod_movie")
     call to_history ("n3",   niter,"mod_movie")    
     call to_history ("esize",4,"mod_movie")

  case(3)  ! FULL EQUATION

     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call to_history ("d1",   1)
     call to_history ("d2",   1)
     call to_history ("d3",   1)    
     call to_history ("o1",   0.)
     call to_history ("o2",   0.)
     call to_history ("o3",   0.)   
     allocate(dtau(n1*n2*n3),tau(n1*n2*n3))
     allocate(hh_2D(n1,n2),px_new(n1,n2,n3))
     allocate(resid(n1*n2*n3))

     dtau=0.
     tau=0.
     call igrad2_2d_init(n1,n2)



     do it=1,n3
        call sep_read(px,"dipx")
        allocate(rand_vec(n2)) 
        call random_number(rand_vec)
        rand_vec=1*(rand_vec-.5)
!!$do ix=1,n2
!!$   px(1:,ix,1)=px(1:,ix,1)*rand_vec(ix)
!!$end do
        do ix=1,n2
           do ip=1,n1
              !            px(ip,ix,1)=(0.000001*(ip**3))!+rand_vec(ix) !(.0005*ip**2)+rand_vec(ix)
              px(ip,ix,1)=cos(real(ip)/50.)!(0.000001*(ip**2))
              !    write(0,*) cos(real(ip)),ip
              !    if (px(ip,ix,1)>8.)  write(0,*) 'too steep', px(ip,ix,1),it,ix
              !   px(ip,ix,1)=(.005*ip) !+rand_vec(ix)
              !      if (px(ip,ix,1)>6.) px(ip,ix,1)=6. ! write(0,*) 'too steep', px(ip,ix,1),it,ip
           end do
        end do
        call to_history("n1",n1,"model_px"); call to_history("n2",n2,"model_px")
        call to_history("n3",n3,"model_px")
!!$  call to_history("d1",d1,"model_px"); call to_history("d2",d2,"model_px")
!!$  call to_history("d3",d3,"model_px")
!!$  call to_history("o1",o1,"model_px"); call to_history("o2",02,"model_px")
!!$  call to_history("o3",o3,"model_px")
        call to_history("esize",4,"model_px")
        call sep_write(px,"model_px")



        px_new=px
        write(0,*) maxval(px),minval(px),sum(px)/size(px)
        rt=0.
        hh=0.


        ! CREATE PTERM
        allocate(p_sqr(n1,n2),p_sqr_dtau(n1,n2),p_sqr_dtau_sm(n1,n2),rt_adj(n1*n2),pterm_cor(n1,n2),pterm_cor_1D(n1*n2))
        pterm_cor=0.
        pterm_cor_1D=0.
        write(0,*) '1max/min',maxval(pterm_cor_1D),minval(pterm_cor_1D)
        ! p_sqr=reshape(px_new,(/size(px)/))
        p_sqr=px(1:,1:,1)*px(1:,1:,1)
        write(0,*) 'p_sqr',maxval(p_sqr),minval(p_sqr)
        do ix=1,n2
           stat1=igrad1_lop(.false.,.false.,p_sqr(1:,ix),p_sqr_dtau(1:,ix))
           !stat1=igrad1_lop(.true.,.false.,p_sqr_dtau(1:,ix),p_sqr(1:,ix))
        end do
        p_sqr_dtau=.5*p_sqr_dtau
        write(0,*) 'p_sqr_dtau',maxval(p_sqr_dtau),minval(p_sqr_dtau)
        rect(1)=10
        rect(2)=1
        n(1)=n1
        n(2)=n2

        ! SMOOTH PTERM

!!$        call triangle_init (60,n1) !70
!!$        do ix=1,n2
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau(1:,ix), p_sqr_dtau_sm(1:,ix))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau_sm(1:,ix), p_sqr_dtau(1:,ix))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau(1:,ix), p_sqr_dtau_sm(1:,ix))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau_sm(1:,ix), p_sqr_dtau(1:,ix))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau(1:,ix), p_sqr_dtau_sm(1:,ix))
!!$        end do
!!$        call triangle_close()
!!$        call triangle_init (55,n2)!55
!!$        do ip=1,n1
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau_sm(ip,1:), p_sqr_dtau(ip,1:))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau(ip,1:), p_sqr_dtau_sm(ip,1:))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau_sm(ip,1:), p_sqr_dtau(ip,1:))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau(ip,1:), p_sqr_dtau_sm(ip,1:))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau_sm(ip,1:), p_sqr_dtau(ip,1:))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau(ip,1:), p_sqr_dtau_sm(ip,1:))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau_sm(ip,1:), p_sqr_dtau(ip,1:))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau(ip,1:), p_sqr_dtau_sm(ip,1:))
!!$        end do
!!$
!!$        call triangle_close()
!!$        call triangle_init (10,n1)
!!$        do ix=1,n2
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau_sm(1:,ix), p_sqr_dtau(1:,ix))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau(1:,ix), p_sqr_dtau_sm(1:,ix))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau_sm(1:,ix), p_sqr_dtau(1:,ix))
!!$           stat1 = triangle_lop (.false., .false., p_sqr_dtau(1:,ix), p_sqr_dtau_sm(1:,ix))
!!$        end do
!!$        p_sqr_dtau=p_sqr_dtau_sm

        allocate( rt( n1*n2))
        do iter=1,niter
           write(0,*) '1'
           rt(1:n1*n2)=reshape(px_new,(/size(px)/))
           write(0,*) '2'
           stat1=igrad2_2d_lop(.true.,.false.,rt_adj , rt)
           !   if (iter/=1)then
           write(0,*) '1'
           pterm_cor=0.
           call correct_div(tau,p_sqr_dtau,pterm_cor)
           ! call correct_div(tau,p_sqr,pterm_cor)
           write(0,*) '2'
           pterm_cor_1D=reshape(pterm_cor,(/size(pterm_cor_1D)/))
           !   end if

           write(0,*) '2max/min',maxval(pterm_cor_1D),minval(pterm_cor_1D)
           rt=rt_adj-n2*pterm_cor_1D  !130
           !rt=rt_adj-n2/2*pterm_cor_1D 
           call dipintegrate_full (rt,dtau,eps_t,n1,n2,ztrans) 

           tau=tau+dtau
           write(0,*) 'px_new',maxval(px_new) , minval(px_new) ,sum(px_new)
           write(0,*) 'tau',maxval(tau) , minval(tau) ,sum(tau)

           call correct_dip_2D  (tau,px,px_new,ref_2)
           write(0,*) maxval(px_new)  
           !  call dipintegrate_3D_slice (rt,hh,eps_t,eps_h,1,n1,n2,ztrans)

           resid=reshape(px_new,(/n1*n2*n3/))
           write(0,*) 'iter',iter,'residual',dot_product(resid,resid)
        end do

        hh_2D=reshape(tau,(/n1,n2/))


        call sep_write (hh_2D(1:n1,1:n2)) !-sum(hh_2D(1:n1,1:n2))/(n1*n2)) 

     end do

     write(0,*) 'finished integration'
     call sep_close()
     call exit (0)

  case(4)  ! 2D integration----1 slice at a time---using conjagate gradients

     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call to_history ("d1",   1)
     call to_history ("d2",   1)
     call to_history ("d3",   1)    
     call to_history ("o1",   0.)
     call to_history ("o2",   0.)
     call to_history ("o3",   0.)   
     allocate(dtau(n1*n2*n3),tau(n1*n2*n3))
     allocate(hh_2D(n1,n2),px_new(n1,n2,n3))
     allocate(resid(n1*n2*n3))

     dtau=0.
     tau=0.
     call igrad2_2d_init(n1,n2)

     do it=50,50 !1,n3
        call sep_read(px,"dipx")
        px_new=px
        write(0,*) maxval(px),minval(px),sum(px)/size(px)
        rt=0.
        hh=0.
        do iter=1,niter
           allocate( rt( n1*n2))
           rt(1:n1*n2)=reshape(px_new,(/size(px)/))

           !call dipintegrate_2D (rt,dtau,eps_t,n1,n2,ztrans) 
           call solver_smp(dtau, rt,igrad2_2d_lop,cgstep,linear_niter,verb=.true.)
           tau=tau+dtau        
           call correct_dip_2D  (tau,px,px_new,ref_2)     
           resid=reshape(px_new,(/n1*n2*n3/))
           write(0,*) 'iter',iter,'residual',dot_product(resid,resid)
        end do


        call sep_write(tau) 

     end do
  case(5)  ! 2D time slice integration---
     write(0,*) 'herea1'
     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call to_history ("d1",   1)
     call to_history ("d2",   1)
     call to_history ("d3",   1)    
     call to_history ("o1",   0.)
     call to_history ("o2",   0.)
     call to_history ("o3",   0.)   
     allocate(dtau(n1*n2*n3),tau(n1*n2*n3))
     allocate(hh_2D(n1,n2),px_new(n1,n2,n3))
     allocate(resid(n1*n2*n3),ww(n1*n2*n3*2))
     allocate( rt( n1*n2*2),rt_new(n1*n2*2))

     dtau=0.
     tau=0.
     call igrad2_init(n1,n2)

     do it=1,n3
        call sep_read(px,"dipx")
        call sep_read(py,"dipy")
        call sep_read(hh_2D,"ww")
        ww=1.
        !   ww(1:n1*n2) =reshape(hh_2D,(/size(hh_2D)/))

        !      write(0,*) maxval(px),minval(px),sum(px)/size(px)

        rt=0.
        hh=0.

        rt(1:n1*n2)        =reshape(px,(/size(px)/))
        rt(n1*n2+1:n1*n2*2)=reshape(py,(/size(py)/))
        rt_new=rt

        do iter=1,niter
           !   allocate( rt( n1*n2))
           !  rt_new(1:n1*n2)=reshape(_new,(/size(px)/))

           call dipintegrate_timeslice (rt_new,dtau,n1,n2,ztrans,eps_h) 
           !    call solver_smp(dtau, rt,igrad2_2d_lop,cgstep,linear_niter,verb=.true.)

           tau=tau+dtau   
           rt_new=-rt
           stat1=igrad2_lop(.false.,.true.,tau,rt_new) ! grad tau -p =r
           rt_new=-1*rt_new
           write(0,*) 'iter',iter

           !  write(0,*) 'n1,n2,n3',n1,n2,n3
           !dtau=0.
           !call correct_dip_3D(dtau,rt,rt_new,n3,n1,n2)  
           write(0,*) 'corrected dips'
           ww=1/(1+rt_new**2/eps_r**2)**2 !ww=1/((1+res**2)**.5/1.)
           !  rt_new=rt_new*ww

           !    call sep_read(ww(1:n1*n2),"park_2D.wt.H")
           !    call sep_read(ww(n1*n2+1:n1*n2*2),"park_2D.wt.H")
           !rt_new=rt
           rt_new=rt_new*ww
           !    resid=reshape(px_new,(/n1*n2*n3/))
           write(0,*) 'iter',iter,'residual',dot_product(rt_new,rt_new)
        end do


        call sep_write(tau) 

        call sep_write (ww,"wt_out") 
        call to_history ("n1",   n1,"wt_out")
        call to_history ("n2",   n2,"wt_out")
        call to_history ("n3",   n3*2,"wt_out")    
        call to_history ("esize",4,"wt_out")

        call sep_write (rt_new,"res") 
        call to_history ("n1",   n1,"res")
        call to_history ("n2",   n2,"res")
        call to_history ("n3",   n3*2,"res")    
        call to_history ("esize",4,"res")

     end do

  case(6) !one slice at a time

     allocate(ztrans(1,2*n2,2*n3))
     write(0,*) 'here',eps_h,n2,n3
     ! PRECOMPUTE ZTRANS OF LAPLACIAN
     call z_trans(1,2*n2,2*n3,0.,eps_h**2,ztrans)
     write(0,*) 'here'
     allocate( rt( n2*n3*2),rt_new(n2*n3*2),tau_3D(n1,n2,n3),tau(n2*n3))
     allocate(dtau(n2*n3))
     allocate(rt_full(n1*n2*n3*2))     
     allocate(tau_2D(n2,n3))
     allocate(px_2D_new(n2,n3),py_2D_new(n2,n3))
     allocate(px_3D(n1,n2,n3),py_3D(n1,n2,n3))
     allocate(ww(n2*n3*2),ww_3D(n1,n2,n3,2),ww_bounds(n2*n3*2),ww_2D_bounds(n2,n3*2))
     allocate(ww_bounds_temp(n2*n3*2))
     allocate(rt_adj2(n2*n3)) !,resid(n2*n3*2))

     ! CREATE WEIGHT BOUNDS
     ww_2D_bounds=1.
     ww_2D_bounds(n2,1:)=0.
     ww_2D_bounds(1:,n3)=0.
     ww_2D_bounds(1:,2*n3)=0.


!!$! temp
!!$  ww_2D_bounds(1,1:)=0.
!!$ ww_2D_bounds(1:,1)=0.
!!$  ww_2D_bounds(1:,n3+1)=0.
!!$ ww_bounds=reshape(ww_2D_bounds,(/n2*n3*2/))
!!$ww_bounds_temp=abs(1.-ww_bounds)

     ww_bounds=reshape(ww_2D_bounds,(/n2*n3*2/))


     ! TEMP DELETE!!!!
     allocate(rt_temp(n2*n3))    

     py=py !*eps_h  !apply epsillon   W[P]
     px_3D=px
     py_3D=py
     tau=0.
     !last_res=res_val
     ww=1.
     ww_3D=1.
     movie_index=0
     if (exist_file("wt_in")) then 
        write(0,*) 'READING IN WEIGHT'
        call sreed("wt_in",ww_3D,4*n1*n2*n3*1)
        px_3D=px_3D*ww_3D(1:,1:,1:,1)
        py_3D=py_3D*ww_3D(1:,1:,1:,1) 
        write(0,*) 'READ IN WEIGHT'
        use_wt=0
     end if
     iteration_counter=0
!!$     do it=50,50,1 !1,n1,1 
     sliceloop: do it=1,n1,1 
        !sliceloop: do it=52,52,1 
        !sliceloop: do it=20,20,1 

        ! INITIALIZE SOLUTION
        ! tau=0.

        previous_dtau=0.

        write(0,*) 'grabbing slice',it,'of',n1,(real(it)/real(n1))*100.,'% complete'
        rt=0.
        hh=0.
        ww=1.

        rt(1:n2*n3)        =reshape(px(it,1:,1:),(/n2*n3/))
        rt(n2*n3+1:n2*n3*2)=reshape(py(it,1:,1:),(/n2*n3/))
        !     end if
        rt_new=rt

        if (exist_file("wt_in")) then
           write(0,*) 'READING IN WEIGHT'

           ww(1:n2*n3)        =reshape(ww_3D(it,1:,1:,1),(/n2*n3/))
           ww(n2*n3+1:2*n2*n3)=reshape(ww_3D(it,1:,1:,1),(/n2*n3/))  
           rt_new=rt_new*ww
        end if


        res_scale=max(1.,sqrt(dot_product(rt_new,rt_new)))
        res_val=1. !res_scale


        call igrad2_init(n2,n3)

        iterloop: do iter=1,niter

           tau_2D=reshape(tau,(/n2,n3/))
           px_2D_new=0.  ! 
           py_2D_new=0.


           ! P - GRAD TAU  =R 
           do ix=1,n2-1
              do iy=1,n3-1
                 shift_var=tau_2D(ix,iy)-tau_2D(ref_2,ref_3)
                 tau_1=floor(it+shift_var)
                 tau_2=ceiling(it+shift_var)
                 upwt=it+shift_var-tau_1
                 downwt=1.-upwt

                 if (tau_1>=1.AND.tau_2<=n1) then
                    p_tau_x=downwt*px_3D(tau_1,ix,iy)+upwt*px_3D(tau_2,ix,iy)
                    p_tau_y=downwt*py_3D(tau_1,ix,iy)+upwt*py_3D(tau_2,ix,iy)

                    dtau_dx=tau_2D(ix+1,iy)-tau_2D(ix,iy)
                    dtau_dy=tau_2D(ix,iy+1)-tau_2D(ix,iy)

                    px_2D_new(ix,iy)=p_tau_x-dtau_dx
                    py_2D_new(ix,iy)=(p_tau_y-dtau_dy)   !*eps_h**2
                 end if
              end do
           end do

           rt_new(1:n2*n3)=reshape(px_2D_new,(/n2*n3/))
           rt_new(n2*n3+1:2*n2*n3)=reshape(py_2D_new,(/n2*n3/))
!!$
!!$if (iter==2) then
!!$     call to_history ("n1",   n2,"junk")
!!$     call to_history ("n2",   n3,"junk")
!!$     call to_history ("n3",   1,"junk")    
!!$     call to_history ("esize",4,"junk")
!!$  call sep_write (rt_new(1:n2*n3) ,"junk") 
!!$stop
!!$end if
           ! IRLS STUFF COMPUTE  W=1/1+RESIDUAL...
           !res_val_diff=res_val-sqrt(dot_product(rt_new,rt_new))/res_scale
           irls_if: if (irls==1) then
              if (real(iter)/wt_iter-floor(real(iter)/wt_iter)<.00001) then
                 ! if (abs(res_val_diff)<stop_tol.and.iter>1.and.irls==1) then
                 write(0,*) 'REWEIGHTING', iter
                 if (real(iter)/1000-floor(real(iter)/1000)<.00001) eps_r=eps_r*.8
                 ww=1/(1+rt_new**2/eps_r**2)**2
                 ww=ww*ww_bounds
                 !temp
                 !ww=ww+ww_bounds_temp


                 !ww=1/(1+.5*(rt_new**2/eps_r**2))
                 !ww(n3+1:)=ww(1:n2*n3-n3)
                 !ww(1:n3)=.0
                 ! ALTERNATIVE WEIGHT
                 ! rt_temp=(abs(rt_new(1:n2*n3)*rt_new(n2*n3+1:)))**.5
                 ! ww(1:n2*n3)=1/((1+rt_temp**2/eps_r**2)**2)
                 ! ww(n2*n3+1:)=ww(1:n2*n3)

                 call sep_write (rt_new,"res_movie")
                 call sep_write (rt_temp,"res")
                 call sep_write (ww(1:n2*n3*2),"wt_movie")
                 ! call sep_write (ww_3D("wt_movie")

                 movie_index=movie_index+1
              end if
           endif irls_if

           ! APPLY WEIGHT  
           rt_new=rt_new*ww

           ! APPLY EPSILLON
           rt_new(n2*n3+1:)=rt_new(n2*n3+1:)*(eps_h**2)      

           ! APPLY DIVERGENCE
           stat1=igrad2_lop(.true.,.false.,rt_adj2 , rt_new) 


           ! DELTA TAU=FFT[R}
           call dipintegrate_timeslice_full (rt_adj2,dtau,n2,n3,ztrans,eps_h)

           ! STOPPING CRITERION
           res_val_diff=res_val-sqrt(dot_product(rt_new,rt_new))/res_scale
           if (abs(res_val_diff)<stop_tol.and.iter>1.and.iter>=min_niter) then
              ext_indicator=1
              exit
           else
              ext_indicator=0
           end if
           iteration_counter=iteration_counter+1

           ! UPDATE SOLUTION
           tau=tau+dtau  


           previous_dtau=dot_product(dtau,dtau)


           res_val=sqrt(dot_product(rt_new,rt_new))/res_scale

        end do iterloop
        tau_3D(it,1:,1:)=reshape(tau,(/n2,n3/))
        ww_3D(it,1:,1:,1:)=reshape(ww,(/n2,n3,2/))
        write(0,*) 'iter',iter,'res',sqrt(dot_product(rt_new,rt_new))/res_scale
     end do sliceloop

     call sep_write(tau_3D) 
     write(0,*) 'EPS_H OUT',eps_h

     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)     
     call to_history ("esize",4)
     call to_history ("d1",   d1)
     call to_history ("d2",   d2)
     call to_history ("d3",   d3)     
     call to_history ("o1",   o1)
     call to_history ("o2",   o2)
     call to_history ("o3",   o3)     

     call sep_write (ww_3D ,"wt_out") 
     call to_history ("n1",   n1,"wt_out")
     call to_history ("n2",   n2,"wt_out")
     call to_history ("n3",   n3,"wt_out")  
     call to_history ("n4",   2 ,"wt_out")  
     call to_history ("esize",4,"wt_out")

!!$     call to_history ("n1",   n2,"mod_movie")
!!$     call to_history ("n2",   n3,"mod_movie")
!!$     call to_history ("n3",   movie_index,"mod_movie")    
!!$     call to_history ("esize",4,"mod_movie")
!!$
!!$     call to_history ("n1",   n2,"wt_movie")
!!$     call to_history ("n2",   n3*2,"wt_movie")
!!$     call to_history ("n3",   movie_index,"wt_movie")    
!!$     call to_history ("esize",4,"wt_movie")
!!$
!!$     call to_history ("n1",   n2,"res_movie")
!!$     call to_history ("n2",   n3*2,"res_movie")
!!$     call to_history ("n3",   movie_index,"res_movie")    
!!$     call to_history ("esize",4,"res_movie")
!!$
!!$     !   call sep_write (rt_new,"res") 
!!$     call to_history ("n1",   n2,"res")
!!$     call to_history ("n2",   n3*2,"res")
!!$     call to_history ("n3",   movie_index,"res")    
!!$     call to_history ("esize",4,"res")

     write(0,*) 'TOTAL ITERATIONS', iteration_counter
     write(0,*) 'eps_r',eps_r
  case(7) !one slice at a time, but looping over all reverence traces

     slice_width=15
     allocate(ztrans(1,2*n2,2*slice_width))
     call z_trans(1,2*n2,2*slice_width,0.,eps_h**2,ztrans)
     allocate( rt( n2*slice_width*2),rt_new(n2*slice_width*2),tau_3D(n1,n2,n3),tau(n2*slice_width))
     allocate(dtau(n2*slice_width))
     !   allocate(rt_full(n1*n2*n3*2))
     allocate(tau_2D(n2,slice_width))
     allocate(px_2D_new(n2,slice_width),py_2D_new(n2,slice_width))
     !   rt_full(1:n1*n2*n3)        =reshape(px,(/n1*n2*n3/))
     !   rt_full(n1*n2*n3+1:n1*n2*n3*2)=reshape(py,(/n1*n2*n3/))
     allocate(px_3D(n1,n2,slice_width),py_3D(n1,n2,slice_width))
     allocate(ww(n2*n3*2),ww_3D(n1,n2,n3,2))
     allocate(tau_slice(n2,slice_width))

     !last_res=res_val
     tau_3D=0.
     ww=1.
     ww_3D=1.
     movie_index=0
     if (exist_file("wt_in")) then 
        write(0,*) 'READING IN WEIGHT'
        call sreed("wt_in",ww_3D,4*n1*n2*n3*1)
        px_3D=px_3D*ww_3D(1:,1:,1:,1)
        py_3D=py_3D*ww_3D(1:,1:,1:,1) 
        write(0,*) 'READ IN WEIGHT'
        use_wt=0
     end if

!!$     do it=50,50,1 !1,n1,1 
     write(0,*) 'end',n3-floor(real(slice_width)/2.)
     refloop:   do ref_3=floor(real(slice_width)/2.)+1,n3-floor(real(slice_width)/2.) ,1
        write(0,*) 'grabbing section',ref_3,'of',n3,(real(ref_3)/real(n3))*100.,'% complete'
        px_3D=px(1:,1:,1+(ref_3-(floor(real(slice_width)/2.)+1)):slice_width+(ref_3-(floor(real(slice_width)/2.)+1)))
        py_3D=py(1:,1:,1+(ref_3-(floor(real(slice_width)/2.)+1)):slice_width+(ref_3-(floor(real(slice_width)/2.)+1)))
        write(0,*) 1+(ref_3-(floor(real(slice_width)/2.)+1)),slice_width+(ref_3-(floor(real(slice_width)/2.)+1))

        do it=1,n1,1 

           !           write(0,*) 'grabbing slice',it,'of',n1,(real(it)/real(n1))*100.,'% complete'
           rt=0.
           !           hh=0.

           rt(1:n2*slice_width)        =reshape(px_3D(it,1:,1:),(/n2*slice_width/))
           rt(n2*slice_width+1:n2*slice_width*2)=reshape(py_3D(it,1:,1:),(/n2*slice_width/))
           rt_new=rt

           if (exist_file("wt_in")) then
              write(0,*) 'READING IN WEIGHT'
              STOP
              ww(1:n2*n3)        =reshape(ww_3D(it,1:,1:,1),(/n2*n3/))
              ww(n2*n3+1:2*n2*n3)=reshape(ww_3D(it,1:,1:,1),(/n2*n3/))  
              rt_new=rt_new*ww
           end if

           tau=0.
           res_scale=dot_product(rt_new,rt_new)
           res_scale=1.
           !     write(0,*) 'iter',0,'residual',1000*(dot_product(rt_new,rt_new)/res_scale)



           do iter=1,niter
              !   allocate( rt( n1*n2))
              !  rt_new(1:n1*n2)=reshape(_new,(/size(px)/))

              call dipintegrate_timeslice (rt_new,dtau,n2,slice_width,ztrans,eps_h) 
              !write(0,*) tau
              !    call solver_smp(dtau, rt,igrad2_2d_lop,cgstep,linear_niter,verb=.true.)
              tau=tau+dtau  
              !  call correct_dip_timeslice (tau,rt_full,rt_new,n1,n2,n3,ref_2,ref_3,it)

!!$
              tau_2D=reshape(tau,(/n2,slice_width/))
              px_2D_new=0.
              py_2D_new=0.

              do ix=1,n2-1
                 do iy=1,slice_width-1
                    shift_var=tau_2D(ix,iy)-tau_2D(ref_2,floor(real(slice_width)/2.)+1)
                    tau_1=floor(it+shift_var)
                    tau_2=ceiling(it+shift_var)
                    upwt=it+shift_var-tau_1
                    downwt=1.-upwt

                    if (tau_1>=1.AND.tau_2<=n1) then
                       p_tau_x=downwt*px_3D(tau_1,ix,iy)+upwt*px_3D(tau_2,ix,iy)
                       p_tau_y=downwt*py_3D(tau_1,ix,iy)+upwt*py_3D(tau_2,ix,iy)

!!!$                 ! LINEAR ....DELETE
!!!$                  p_tau_x=px_3D(it,ix,iy)
!!!$                  p_tau_y=py_3D(it,ix,iy)

                       dtau_dx=tau_2D(ix+1,iy)-tau_2D(ix,iy)
                       dtau_dy=tau_2D(ix,iy+1)-tau_2D(ix,iy)

                       px_2D_new(ix,iy)=p_tau_x-dtau_dx
                       py_2D_new(ix,iy)=eps_h*(p_tau_y-dtau_dy)
                    end if
!!!$                 if (tau_1<1.or.tau_2>n1) then 
!!!$                    px_2D_new(ix,iy)=0. 
!!!$                    py_2D_new(ix,iy)=0.
!!!$                 end if

                 end do
              end do
              !  end do

              rt_new(1:n2*slice_width)=reshape(px_2D_new,(/n2*slice_width/))
              rt_new(n2*slice_width+1:2*n2*slice_width)=reshape(py_2D_new,(/n2*slice_width/))

              if (exist_file("wt_in"))  rt_new=rt_new*ww

              ! deallocate(tau_2D,px_3D,py_3D)
              ! deallocate(px_2D_new,py_2D_new)



              !    resid=reshape(px_new,(/n1*n2*n3/))
              !        if (iter==1) res_scale=dot_product(rt_new,rt_new)
              res_val=1000*(dot_product(rt_new,rt_new)/res_scale)
              ! res_val=dot_product(rt_new,rt_new)
!!$           write(0,*) 'iter',iter,'residual',res_val,maxval(rt_new),minval(rt_new)


              !  if (last_res-res_val<.001.and.iter>5.and.res_val<10.) exit
              last_res=res_val
              if (irls==1) then
                 if (real(iter)/wt_iter-floor(real(iter)/wt_iter)<.01) then
                    write(0,*) 'REWEIGHTING'
                    ww=1/(1+rt_new**2/eps_r**2)**2
                    !  ww_3D=reshape(ww,(/n1,n2,n3,2/))


                    !    tau_3D=reshape(tau,(/n1,n2,n3/))
                    !    res_3D=reshape(rt_new(1:n1*n2*n3),(/n1,n2,n3/))
                    movie_index=movie_index+1

!!$              call sep_write (tau,"mod_movie")
!!$              !     call sep_write (res_3D(1:,1:,nint(5.*real(n3)/6.)),"res_movie")
!!$              call sep_write (rt_new(1:n2*n3),"res_movie")
!!$              call sep_write (ww(1:n2*n3),"wt_movie")
                    !        call sep_write (rt_new,"res_cube_movie")
                    ! tau=0.
                 end if
              endif
              rt_new=rt_new*ww


           end do
           tau_slice=reshape(tau,(/n2,slice_width/))

           tau_3D(it,1:,ref_3)=tau_slice(1:,floor(real(slice_width)/2.)+1)
           !write(0,*) 'UPPER LIMET N3',size(tau_3D(it,1,1:))


        end do

     end do refloop

!!$     call sep_write(tau)  
     call sep_write(tau_3D) 

!!$     call to_history ("n1",   n2) 
!!$     call to_history ("n2",   n3)
!!$     call to_history ("n3",   1)   
!!$     call to_history ("esize",4)

     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)     
     call to_history ("esize",4)



     call sep_write (ww,"wt_out") 
     call to_history ("n1",   n1,"wt_out")
     call to_history ("n2",   n2,"wt_out")
     call to_history ("n3",   n3*2,"wt_out")    
     call to_history ("esize",4,"wt_out")

     call to_history ("n1",   n2,"mod_movie")
     call to_history ("n2",   n3,"mod_movie")
     call to_history ("n3",   movie_index,"mod_movie")    
     call to_history ("esize",4,"mod_movie")

     call to_history ("n1",   n2,"wt_movie")
     call to_history ("n2",   n3,"wt_movie")
     call to_history ("n3",   movie_index,"wt_movie")    
     call to_history ("esize",4,"wt_movie")

     call to_history ("n1",   n2,"res_movie")
     call to_history ("n2",   n3,"res_movie")
     call to_history ("n3",   movie_index,"res_movie")    
     call to_history ("esize",4,"res_movie")

     call sep_write (rt_new,"res") 
     call to_history ("n1",   n1,"res")
     call to_history ("n2",   n2,"res")
     call to_history ("n3",   n3*2,"res")    
     call to_history ("esize",4,"res")


  case(8) ! SECOND ATTEMPT AT FULL EQUATION

     allocate(ztrans(1,2*n2,2*n3))
     call z_trans(1,2*n2,2*n3,0.,eps_h**2,ztrans)

!!$
!!$     call sep_write (imag(ztrans),"ztrans") 
!!$     call to_history ("n1",   n2*2,"ztrans")
!!$     call to_history ("n2",   n3*3,"ztrans")
!!$     call to_history ("n3",   1,"ztrans")    
!!$     call to_history ("esize",4,"ztrans")


     allocate( rt( n2*n3*2),rt_new(n2*n3*2),tau_3D(n1,n2,n3),tau(n2*n3))
     allocate(dtau(n2*n3))
     allocate(rt_full(n1*n2*n3*2))
     allocate(tau_2D(n2,n3))
     allocate(px_2D_new(n2,n3),py_2D_new(n2,n3))
     !     rt_full(1:n1*n2*n3)        =reshape(px,(/n1*n2*n3/))
     !     rt_full(n1*n2*n3+1:n1*n2*n3*2)=reshape(py,(/n1*n2*n3/))
     allocate(px_3D(n1,n2,n3),py_3D(n1,n2,n3))
     allocate(p_sqr2(n1,n2,n3),thrd_trm(n1,n2,n3))
     allocate(p_sqr2_1D(n1*n2*n3),thrd_trm_1D(n1*n2*n3))
     allocate(ww(n2*n3*2),ww_3D(n1,n2,n3,2))
     allocate(rt_adj2(n2*n3))
     allocate(tau_sample(n2*n3))

     py=py !*eps_h  !apply epsillon   W[P]
     px_3D=px
     py_3D=py

     ! THIRD TERM
     p_sqr2=px**2+py**2
     p_sqr2_1D=reshape(p_sqr2,(/n1*n2*n3/))
     call igrad1_3d_init(n1,n2,n3)
     !stat1=igrad1_3d_lop(.true.,.false.,thrd_trm_1D , p_sqr2_1D)
     stat1=igrad1_3d_lop(.false.,.false.,p_sqr2_1D   , thrd_trm_1D)
     thrd_trm_1D=.5*thrd_trm_1D

     thrd_trm=reshape(thrd_trm_1D,(/n1,n2,n3/))
     !write(0,*) maxval(thrd_trm)

     !last_res=res_val
     ww=1.
     ww_3D=1.
     movie_index=0
     if (exist_file("wt_in")) then 
        write(0,*) 'READING IN WEIGHT'
        call sreed("wt_in",ww_3D,4*n1*n2*n3*1)
        px_3D=px_3D*ww_3D(1:,1:,1:,1)
        py_3D=py_3D*ww_3D(1:,1:,1:,1) 
        write(0,*) 'READ IN WEIGHT'
        use_wt=0
     end if

!!$     do it=50,50,1 !1,n1,1 
     do it=1,n1,1 

        write(0,*) 'grabbing slice',it,'of',n1,(real(it)/real(n1))*100.,'% complete'
        rt=0.
        hh=0.

        rt(1:n2*n3)        =reshape(px(it,1:,1:),(/n2*n3/))
        !     if (it==1) then
        !        rt(n2*n3+1:n2*n3*2)=eps_h*(reshape(py(it,1:,1:),(/n2*n3/)))
        !     else
        rt(n2*n3+1:n2*n3*2)=reshape(py(it,1:,1:),(/n2*n3/))
        !     end if
        rt_new=rt

        if (exist_file("wt_in")) then
           write(0,*) 'READING IN WEIGHT'
           STOP
           ww(1:n2*n3)        =reshape(ww_3D(it,1:,1:,1),(/n2*n3/))
           ww(n2*n3+1:2*n2*n3)=reshape(ww_3D(it,1:,1:,1),(/n2*n3/))  
           rt_new=rt_new*ww
        end if

        tau=0.
        res_scale=dot_product(rt_new,rt_new)
        res_scale=1.
        !     write(0,*) 'iter',0,'residual',1000*(dot_product(rt_new,rt_new)/res_scale)


        call igrad2_init(n2,n3)
        stat1=igrad2_lop(.true.,.false.,rt_adj2 , rt)

        tau_sample=0.
        call cube_tau_sample(thrd_trm,tau,tau_sample,n1,n2,n3,ref_2,ref_3,it)

        rt_adj2=rt_adj2+tau_sample

        do iter=1,niter
           !   allocate( rt( n1*n2))
           !  rt_new(1:n1*n2)=reshape(_new,(/size(px)/))

           call dipintegrate_timeslice_full (rt_adj2,dtau,n2,n3,ztrans,eps_h) 
           !    call solver_smp(dtau, rt,igrad2_2d_lop,cgstep,linear_niter,verb=.true.)
           tau=tau+dtau  
           !  call correct_dip_timeslice (tau,rt_full,rt_new,n1,n2,n3,ref_2,ref_3,it)

!!$
           tau_2D=reshape(tau,(/n2,n3/))
           px_2D_new=0.
           py_2D_new=0.

           do ix=1,n2-1
              do iy=1,n3-1
                 shift_var=tau_2D(ix,iy)-tau_2D(ref_2,ref_3)
                 tau_1=floor(it+shift_var)
                 tau_2=ceiling(it+shift_var)
                 upwt=it+shift_var-tau_1
                 downwt=1.-upwt

                 if (tau_1>=1.AND.tau_2<=n1) then
                    p_tau_x=downwt*px_3D(tau_1,ix,iy)+upwt*px_3D(tau_2,ix,iy)
                    p_tau_y=downwt*py_3D(tau_1,ix,iy)+upwt*py_3D(tau_2,ix,iy)

!!!$                 ! LINEAR ....DELETE
!!!$                  p_tau_x=px_3D(it,ix,iy)
!!!$                  p_tau_y=py_3D(it,ix,iy)

                    dtau_dx=tau_2D(ix+1,iy)-tau_2D(ix,iy)
                    dtau_dy=tau_2D(ix,iy+1)-tau_2D(ix,iy)

                    px_2D_new(ix,iy)=p_tau_x -dtau_dx
                    py_2D_new(ix,iy)=(p_tau_y -dtau_dy) !*eps_h
                 end if
!!!$                 if (tau_1<1.or.tau_2>n1) then 
!!!$                    px_2D_new(ix,iy)=0. 
!!!$                    py_2D_new(ix,iy)=0.
!!!$                 end if

              end do
           end do
           !  end do

           rt_new(1:n2*n3)=reshape(px_2D_new,(/n2*n3/))
           rt_new(n2*n3+1:2*n2*n3)=reshape(py_2D_new,(/n2*n3/))

           if (exist_file("wt_in"))  rt_new=rt_new*ww

           ! deallocate(tau_2D,px_3D,py_3D)
           ! deallocate(px_2D_new,py_2D_new)



           !    resid=reshape(px_new,(/n1*n2*n3/))
           !        if (iter==1) res_scale=dot_product(rt_new,rt_new)
           res_val=1000*(dot_product(rt_new,rt_new)/res_scale)
           ! res_val=dot_product(rt_new,rt_new)
!!$           write(0,*) 'iter',iter,'residual',res_val,maxval(rt_new),minval(rt_new)


           !  if (last_res-res_val<.001.and.iter>5.and.res_val<10.) exit
           last_res=res_val
           if (irls==1) then
              if (real(iter)/wt_iter-floor(real(iter)/wt_iter)<.01) then
                 write(0,*) 'REWEIGHTING'
                 ww=1/(1+rt_new**2/eps_r**2)**2
                 !  ww_3D=reshape(ww,(/n1,n2,n3,2/))


                 !    tau_3D=reshape(tau,(/n1,n2,n3/))
                 !    res_3D=reshape(rt_new(1:n1*n2*n3),(/n1,n2,n3/))
                 movie_index=movie_index+1

!!$              call sep_write (tau,"mod_movie")
!!$              !     call sep_write (res_3D(1:,1:,nint(5.*real(n3)/6.)),"res_movie")
!!$              call sep_write (rt_new(1:n2*n3),"res_movie")
!!$              call sep_write (ww(1:n2*n3),"wt_movie")
                 !        call sep_write (rt_new,"res_cube_movie")
                 ! tau=0.
              end if
           endif
           rt_new=rt_new*ww
           call igrad2_init(n2,n3)
           stat1=igrad2_lop(.true.,.false.,rt_adj2 , rt_new)
           tau_sample=0.
           call cube_tau_sample(thrd_trm,tau,tau_sample,n1,n2,n3,ref_2,ref_3,it)
           rt_adj2=rt_adj2+tau_sample

        end do
        tau_3D(it,1:,1:)=reshape(tau,(/n2,n3/))


     end do
!!$     call sep_write(tau)  
     call sep_write(tau_3D) 
     write(0,*) 'EPS_H OUT',eps_h
!!$     call to_history ("n1",   n2) 
!!$     call to_history ("n2",   n3)
!!$     call to_history ("n3",   1)   
!!$     call to_history ("esize",4)

     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)     
     call to_history ("esize",4)



     call sep_write (ww,"wt_out") 
     call to_history ("n1",   n1,"wt_out")
     call to_history ("n2",   n2,"wt_out")
     call to_history ("n3",   n3*2,"wt_out")    
     call to_history ("esize",4,"wt_out")

     call to_history ("n1",   n2,"mod_movie")
     call to_history ("n2",   n3,"mod_movie")
     call to_history ("n3",   movie_index,"mod_movie")    
     call to_history ("esize",4,"mod_movie")

     call to_history ("n1",   n2,"wt_movie")
     call to_history ("n2",   n3,"wt_movie")
     call to_history ("n3",   movie_index,"wt_movie")    
     call to_history ("esize",4,"wt_movie")

     call to_history ("n1",   n2,"res_movie")
     call to_history ("n2",   n3,"res_movie")
     call to_history ("n3",   movie_index,"res_movie")    
     call to_history ("esize",4,"res_movie")

     call sep_write (rt_new,"res") 
     call to_history ("n1",   n1,"res")
     call to_history ("n2",   n2,"res")
     call to_history ("n3",   n3*2,"res")    
     call to_history ("esize",4,"res")

  case(9)  ! 2D integration full equation....shooting for the fasted using fft's

     allocate(ztrans(n1,2*n2,1),px(n1,n2,1))
     call z_trans(n1,2*n2,1,eps_t,0.,ztrans)


     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call to_history ("d1",   1)
     call to_history ("d2",   1)
     call to_history ("d3",   1)    
     call to_history ("o1",   0.)
     call to_history ("o2",   0.)
     call to_history ("o3",   0.)   
     allocate(dtau(n1*n2*1),tau(n1*n2*1))
     allocate(tau_2D(n1,n2))
     allocate(hh_2D(n1,n2),px_new(n1,n2,1))
     allocate(resid(n1*n2*1))
     allocate( rt( n1*n2),rt_adj(n1*n2))
     allocate(tau_sample(n1*n2))
     allocate(tau_sample_3D(n1,n2,1))
     allocate(p_sqr2(n1,n2,1),thrd_trm(n1,n2,1))
     allocate(p_sqr2_1D(n1*n2*1),thrd_trm_1D(n1*n2*1),thrd_trm_int(n1*n2*1))
!!$n1=3; n2=100
!!$deallocate(rt,dtau,ztrans)
!!$allocate(rt(n1*n2),dtau(n1*n2))
!!$ allocate(ztrans(n1,2*n2,1))
!!$     call z_trans(n1,2*n2,1,eps_t,0.,ztrans)
!!$rt=-1.
!!$  call leakint_2D_init(n1,n2,1.) 
!!$ stat1=leakint_2D_lop(.false.,.false.,rt,dtau)
!!$!  call dipintegrate_2D (rt,dtau,eps_t,n1,n2,ztrans) 
!!$write(0,*) 'dtau',dtau -sum(dtau)/(n1*n2)
!!$stop

     dtau=0.
     tau=0.
     call leakint_2D_init(n1,n2,1.) ! INTEGRATE ALONG X DIRECTION


     do it=1,n3

        call sep_read(px,"dipx")
        px_new=px
        write(0,*) maxval(px),minval(px),sum(px)/size(px)
        ! rt(1:n1*n2)=reshape(px_new,(/size(px)/))
        ! THIRD TERM
        p_sqr2=px**2
        p_sqr2_1D=reshape(p_sqr2,(/n1*n2/))
        call igrad1_2d_init(n1,n2)
        stat1=igrad1_2d_lop(.false.,.false.,p_sqr2_1D   , thrd_trm_1D)
!!$        stat1=igrad1_2d_lop(.true.,.false.,thrd_trm_1D  , p_sqr2_1D)
        thrd_trm_1D=.5*thrd_trm_1D
        !        stat1=leakint_2D_lop(.true.,.false.,thrd_trm_int,thrd_trm_1D)
!!$        stat1=leakint_2D_lop(.false.,.false.,thrd_trm_1D,thrd_trm_int)
!!$        thrd_trm_1D=thrd_trm_int
        thrd_trm=reshape(thrd_trm_1D,(/n1,n2,1/))
        !      rt=0.
        hh=0.
        tau=0.
        dtau=0.

        tau_2D=reshape(tau,(/n1,n2/))
        do i1=1,n1
           call section_tau_sample(thrd_trm,tau_2D(i1,1:),tau_sample_3D(i1,1:,1),n1,n2,ref_2,i1)
        end do
        thrd_trm_1D=reshape(tau_sample_3D,(/n1*n2/))
        stat1=leakint_2D_lop(.false.,.false.,thrd_trm_1D,thrd_trm_int)
!!$    stat1=leakint_2D_lop(.true.,.false.,thrd_trm_int,thrd_trm_1D)
        thrd_trm_1D=thrd_trm_int
        px_new=px_new+reshape(thrd_trm_1D,(/n1,n2,1/))
        !   px_new=px_new+.5*p_sqr2

        ! px_new=px_new+tau_sample_3D

        ! px_new=px_new+thrd_trm

        do iter=1,niter
           !  allocate( rt( n1*n2))

           rt(1:n1*n2)=reshape(px_new,(/size(px)/))
           !  call igrad2_2d_init(n1,n2)
           !  stat1=igrad2_2d_lop(.true.,.false.,rt_adj , rt)
!!$rt_adj=rt_adj+thrd_trm_1D !reshape(thrd_trm,(/n1*n2/))
           rt_adj=0.
           rt_adj(n1+1:n1*n2)=rt(1:n1*n2-n1)
           rt=rt_adj

           stat1=leakint_2D_lop(.false.,.false.,rt,dtau)
           !  call dipintegrate_2D_section (rt_adj,dtau,eps_t,n1,n2,ztrans) 
           !  call dipintegrate_2D(rt,dtau,eps_t,n1,n2,ztrans) 
           !!           stat1=leakint_2D_lop(.true.,.false.,dtau,rt_adj)
           ! stat1=leakint_2D_lop(.false.,.false.,dtau,rt_adj)
           !!dtau=rt_adj

           tau=tau+dtau
           write(0,*) maxval(px_new)   
           call correct_dip_2D  (tau,px,px_new,ref_2)


           ! UPDATE WITH THIRD TERM
           tau_2D=reshape(tau,(/n1,n2/))
!!$           do i1=1,n1
!!$              call section_tau_sample(thrd_trm,tau_2D(i1,1:),tau_sample_3D(i1,1:,1),n1,n2,ref_2,i1)
!!$           end do

           p_sqr2=px_new**2
           do i1=1,n1
              call section_tau_sample(p_sqr2,tau_2D(i1,1:),tau_sample_3D(i1,1:,1),n1,n2,ref_2,i1)
           end do
           p_sqr2_1D  =reshape(tau_sample_3D,(/n1*n2/))
           stat1=igrad1_2d_lop(.false.,.false.,p_sqr2_1D   , thrd_trm_1D)
!!$        stat1=igrad1_2d_lop(.true.,.false.,thrd_trm_1D  , p_sqr2_1D)
           thrd_trm_1D=.5*thrd_trm_1D
           stat1=leakint_2D_lop(.false.,.false.,thrd_trm_1D,thrd_trm_int)
!!$           stat1=leakint_2D_lop(.true.,.false.,thrd_trm_int,thrd_trm_1D)

           thrd_trm_1D=thrd_trm_int
           !px_new=px_new+reshape(thrd_trm_1D,(/n1,n2,1/))
           !  px_new=px_new+tau_sample_3D




           write(0,*) maxval(px_new)   
           !  call dipintegrate_3D_slice (rt,hh,eps_t,eps_h,1,n1,n2,ztrans)

           resid=reshape(px_new,(/n1*n2*1/))
           write(0,*) 'iter',iter,'residual',dot_product(resid,resid)
           call sep_write (tau,"mod_movie")
        end do

        hh_2D=reshape(tau,(/n1,n2/))


        call sep_write (hh_2D(1:n1,1:n2)) !-sum(hh_2D(1:n1,1:n2))/(n1*n2)) 
     end do

     !DELETE !!!
!!$     do it=1,n1
!!$        hh_2D(it,1:)=it
!!$     end do
!!$     call sep_write (hh_2D(1:n1,1:n2),"junk")
!!$     call to_history ("n1",   n1,"junk")
!!$     call to_history ("n2",   n2,"junk")

     call to_history ("n1",   n1,"mod_movie")
     call to_history ("n2",   n2,"mod_movie")
     call to_history ("n3",   niter,"mod_movie")    
     call to_history ("esize",4,"mod_movie")

  case(10)  ! 1D integration----1 slice at a time in time domain using causal integration...fastest theoretically

     allocate(ztrans(n1,2*n2,1),px(n1,n2,1))
     call z_trans(n1,2*n2,1,eps_t,0.,ztrans)


     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call to_history ("d1",   1)
     call to_history ("d2",   1)
     call to_history ("d3",   1)    
     call to_history ("o1",   0.)
     call to_history ("o2",   0.)
     call to_history ("o3",   0.)   
     allocate(dtau(n1*n2*1),tau(n1*n2*1))
     allocate(tau_2D(n1,n2))
     allocate(hh_2D(n1,n2),px_new(n1,n2,1))
     allocate(resid(n1*n2*1))
     allocate( rt( n1*n2),rt_adj(n1*n2))
     allocate(tau_sample(n1*n2))
     allocate(tau_sample_3D(n1,n2,1))
     allocate(p_sqr2(n1,n2,1),thrd_trm(n1,n2,1))
     allocate(p_sqr2_1D(n1*n2*1),thrd_trm_1D(n1*n2*1),thrd_trm_int(n1*n2*1))

     dtau=0.
     tau=0.
     call leakint_2D_init(n1,n2,1.) ! INTEGRATE ALONG X DIRECTION
     call leakint_init (1.)
     call igrad2_2d_init(n1,n2)
     tau=0.

     do it=1,n3
        px_new=0.

        call sep_read(px,"dipx")
        px_new=px
        hh=0.
        dtau=0.

        rt(1:n1*n2)=reshape(px_new,(/n1*n2/))
        res_scale=max(1.,sqrt(dot_product(rt,rt)))
        res_val=1. !res_scale   

        do iter=1,niter
           call correct_dip_2D  (tau,px,px_new,ref_2)

           resid=reshape(px_new,(/n1*n2*1/))

           ! STOPPING CRITERION
           res_val_diff=res_val-sqrt(dot_product(resid,resid))/res_scale
           !          if (dot_product(resid,resid)/(n1*n2)<stop_tol.and.iter>=min_niter) exit
           if (abs(res_val_diff)<stop_tol.and.iter>1.and.iter>=min_niter) exit

           rt(1:n1*n2)=reshape(px_new,(/size(px)/))


           rt_adj=0.
           rt_adj(n1+1:n1*n2)=rt(1:n1*n2-n1)
           rt=rt_adj

           stat1=leakint_2D_lop(.false.,.false.,rt,dtau)

           tau=tau+dtau

           res_val=sqrt(dot_product(rt,rt))/res_scale
           write(0,*) 'iter',iter,'residual',res_val
        end do

        write(0,*) 'gather',it,'of',n3,'iter',iter,'residual',res_val

        hh_2D=reshape(tau,(/n1,n2/))


        call sep_write (hh_2D(1:n1,1:n2)) !-sum(hh_2D(1:n1,1:n2))/(n1*n2)) 
     end do

!!$     call sep_write (hh_2D(1:n1,1:n2),"junk")
!!$     call to_history ("n1",   n1,"junk")
!!$     call to_history ("n2",   n2,"junk")

!!$     call to_history ("n1",   n1,"mod_movie")
!!$     call to_history ("n2",   n2,"mod_movie")
!!$     call to_history ("n3",   niter,"mod_movie")    
!!$     call to_history ("esize",4,"mod_movie")



  case(11)  ! 2D integration----1 slice at a time in time domain using causal integration...fastest theoretically plus adding correction term to speed convergence

     allocate(ztrans(n1,2*n2,1),px(n1,n2,1))
     call z_trans(n1,2*n2,1,eps_t,0.,ztrans)


     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call to_history ("d1",   1)
     call to_history ("d2",   1)
     call to_history ("d3",   1)    
     call to_history ("o1",   0.)
     call to_history ("o2",   0.)
     call to_history ("o3",   0.)   
     allocate(dtau(n1*n2*1),tau(n1*n2*1))
     allocate(tau_2D(n1,n2))
     allocate(hh_2D(n1,n2),px_new(n1,n2,1))
     allocate(resid(n1*n2*1))
     allocate( rt( n1*n2),rt_adj(n1*n2))
     allocate(tau_sample(n1*n2))
     allocate(tau_sample_3D(n1,n2,1))
     allocate(p_sqr2(n1,n2,1),thrd_trm(n1,n2,1))
     allocate(p_sqr2_1D(n1*n2*1),thrd_trm_1D(n1*n2*1),thrd_trm_int(n1*n2*1))
     allocate(dip_diff(n1*n2),dip_integ(n1*n2),dip_integ2D(n1,n2),px_1D(n1*n2))
     allocate(dip_correction(n1,n2))
     dtau=0.
     tau=0.
     call leakint_2D_init(n1,n2,1.) ! INTEGRATE ALONG X DIRECTION
     call leakint_init (1.)
     call igrad2_2d_init(n1,n2)
     call leakint2_init(n1,n2,1.)

     tau=0.

     do it=1,n3
        px_new=0.

        call sep_read(px,"dipx")

        px_new=px
        hh=0.
        dtau=0.
        ! tau=0.
        !     

        do iter=1,niter
           call correct_dip_2D  (tau,px,px_new,ref_2)

           resid=reshape(px_new,(/n1*n2*1/))
           write(0,*) 'iter',iter-1,'residual',dot_product(resid,resid)/(n1*n2)
           if (dot_product(resid,resid)/(n1*n2)<stop_tol) exit

           rt(1:n1*n2)=reshape(px_new,(/size(px)/))


           rt_adj=0.
           rt_adj(n1+1:n1*n2)=rt(1:n1*n2-n1)
           rt=rt_adj

           stat1=leakint_2D_lop(.false.,.false.,rt,dtau)

           ! NEW CORRECTION

           !  dip_diff(1:,icol)=px(1:,icol,1)-px(nint(tau(ir,ic)),icol,1)
           px_1D=reshape(px,(/size(px)/))
           stat1=leakint2_lop(.false.,.false.,px_1D ,dip_integ) 
           dip_integ2D=reshape(dip_integ,(/n1,n2/))
           tau=tau+dtau

           tau_2D=reshape(tau,(/n1,n2/))
           do iz=1,n1
              do iv=1,n2
                 if (iz+nint(tau_2D(iz,iv)-tau_2D(iz,ref_2)) <=n1.and.iz+nint(tau_2D(iz,iv)-tau_2D(iz,ref_2)) >=1) then
                    dip_correction(iz,iv)=dip_integ2D(iz+nint(tau_2D(iz,iv)-tau_2D(iz,ref_2)),iv)-px(iz,iv,1)*abs(tau_2D(iz,iv)-tau_2D(iz,ref_2))
                 end if
              end do
           end do
           do iz=1,n1
              do iv=1,n2
                 ! dip_integ2D(iz,iv)=sum(dip_correction(max(1,iz-3):min(iz+3,n1),max(1,iv):min(iv+3,n2)))/36
                 dip_integ2D(iz,iv)=sum(dip_correction(iz,1:))/n2
              end do
           end do
           !dip_correction=dip_integ2D

           tau=tau-reshape(dip_correction,(/n1*n2/))
!!$
!!$           call sep_write (dip_correction,"junk1a.H")
!!$           call to_history ("n1",   n1,"junk1a.H")
!!$           call to_history ("n2",   n2,"junk1a.H")
!!$           call to_history ("n3",   1,"junk1a.H")    
!!$           call to_history ("esize",4,"junk1a.H")
           !   stop

           !  tau=tau+dtau



        end do

        hh_2D=reshape(tau,(/n1,n2/))


        call sep_write (hh_2D(1:n1,1:n2)) !-sum(hh_2D(1:n1,1:n2))/(n1*n2)) 
     end do
!!$
!!$     call sep_write (hh_2D(1:n1,1:n2),"junk")
!!$     call to_history ("n1",   n1,"junk")
!!$     call to_history ("n2",   n2,"junk")

     call to_history ("n1",   n1,"mod_movie")
     call to_history ("n2",   n2,"mod_movie")
     call to_history ("n3",   niter,"mod_movie")    
     call to_history ("esize",4,"mod_movie")


  case(12) !one slice at a time, but less ram demand...a version of case(6)

     allocate(ztrans(1,2*n2,2*n3))

     ! PRECOMPUTE ZTRANS OF LAPLACIAN
     call z_trans(1,2*n2,2*n3,0.,eps_h**2,ztrans)

     allocate( rt( n2*n3*2),rt_new(n2*n3*2),tau_3D(n1,n2,n3),tau(n2*n3))
     allocate(dtau(n2*n3))
     !    allocate(rt_full(n1*n2*n3*2))     
     allocate(tau_2D(n2,n3))
     allocate(px_2D_new(n2,n3),py_2D_new(n2,n3))
     allocate(px_3D(n1,n2,n3),py_3D(n1,n2,n3))
     !  allocate(ww(n2*n3*2),ww_3D(n1,n2,n3,2),ww_bounds(n2*n3*2),ww_2D_bounds(n2,n3*2))
     !  allocate(ww_bounds_temp(n2*n3*2))
     allocate(rt_adj2(n2*n3)) !,resid(n2*n3*2))
     write(0,*) 'after allocations'
     ! CREATE WEIGHT BOUNDS
!!$     ww_2D_bounds=1.
!!$     ww_2D_bounds(n2,1:)=0.
!!$     ww_2D_bounds(1:,n3)=0.
!!$     ww_2D_bounds(1:,2*n3)=0.
     call sep_read(px_3D,"dipx")
     call sep_read(py_3D,"dipy")

!!$! temp
!!$  ww_2D_bounds(1,1:)=0.
!!$ ww_2D_bounds(1:,1)=0.
!!$  ww_2D_bounds(1:,n3+1)=0.
!!$ ww_bounds=reshape(ww_2D_bounds,(/n2*n3*2/))
!!$ww_bounds_temp=abs(1.-ww_bounds)

!!$     ww_bounds=reshape(ww_2D_bounds,(/n2*n3*2/))


     ! TEMP DELETE!!!!
     ! allocate(rt_temp(n2*n3))    


     tau=0.
     !last_res=res_val

     movie_index=0

     iteration_counter=0
!!$     do it=50,50,1 !1,n1,1 
     sliceloop2: do it=1,n1,1 
        !sliceloop: do it=52,52,1 
        !sliceloop: do it=20,20,1 

        ! INITIALIZE SOLUTION
        ! tau=0.

        previous_dtau=0.

        write(0,*) 'grabbing slice',it,'of',n1,(real(it)/real(n1))*100.,'% complete'
        rt=0.
        hh=0.
        ww=1.

        rt(1:n2*n3)        =reshape(px_3D(it,1:,1:),(/n2*n3/))
        rt(n2*n3+1:n2*n3*2)=reshape(py_3D(it,1:,1:),(/n2*n3/))
        !     end if
        rt_new=rt

        if (exist_file("wt_in")) then
           write(0,*) 'READING IN WEIGHT'

           ww(1:n2*n3)        =reshape(ww_3D(it,1:,1:,1),(/n2*n3/))
           ww(n2*n3+1:2*n2*n3)=reshape(ww_3D(it,1:,1:,1),(/n2*n3/))  
           rt_new=rt_new*ww
        end if


        res_scale=max(1.,sqrt(dot_product(rt_new,rt_new)))
        res_val=1. !res_scale


        call igrad2_init(n2,n3)

        iterloop2: do iter=1,niter

           tau_2D=reshape(tau,(/n2,n3/))
           px_2D_new=0.  ! 
           py_2D_new=0.


           ! P - GRAD TAU  =R 
           do ix=1,n2-1
              do iy=1,n3-1
                 shift_var=tau_2D(ix,iy)-tau_2D(ref_2,ref_3)
                 tau_1=floor(it+shift_var)
                 tau_2=ceiling(it+shift_var)
                 upwt=it+shift_var-tau_1
                 downwt=1.-upwt

                 if (tau_1>=1.AND.tau_2<=n1) then
                    p_tau_x=downwt*px_3D(tau_1,ix,iy)+upwt*px_3D(tau_2,ix,iy)
                    p_tau_y=downwt*py_3D(tau_1,ix,iy)+upwt*py_3D(tau_2,ix,iy)

                    dtau_dx=tau_2D(ix+1,iy)-tau_2D(ix,iy)
                    dtau_dy=tau_2D(ix,iy+1)-tau_2D(ix,iy)

                    px_2D_new(ix,iy)=p_tau_x-dtau_dx
                    py_2D_new(ix,iy)=(p_tau_y-dtau_dy)   !*eps_h**2
                 end if
              end do
           end do

           rt_new(1:n2*n3)=reshape(px_2D_new,(/n2*n3/))
           rt_new(n2*n3+1:2*n2*n3)=reshape(py_2D_new,(/n2*n3/))
!!$
!!$if (iter==2) then
!!$     call to_history ("n1",   n2,"junk")
!!$     call to_history ("n2",   n3,"junk")
!!$     call to_history ("n3",   1,"junk")    
!!$     call to_history ("esize",4,"junk")
!!$  call sep_write (rt_new(1:n2*n3) ,"junk") 
!!$stop
!!$end if
           ! IRLS STUFF COMPUTE  W=1/1+RESIDUAL...
           !res_val_diff=res_val-sqrt(dot_product(rt_new,rt_new))/res_scale
           irls_if2: if (irls==1) then
              if (real(iter)/wt_iter-floor(real(iter)/wt_iter)<.00001) then
                 ! if (abs(res_val_diff)<stop_tol.and.iter>1.and.irls==1) then
                 write(0,*) 'REWEIGHTING', iter
                 if (real(iter)/1000-floor(real(iter)/1000)<.00001) eps_r=eps_r*.8
                 ww=1/(1+rt_new**2/eps_r**2)**2
                 ww=ww*ww_bounds
                 !temp
                 !ww=ww+ww_bounds_temp


                 !ww=1/(1+.5*(rt_new**2/eps_r**2))
                 !ww(n3+1:)=ww(1:n2*n3-n3)
                 !ww(1:n3)=.0
                 ! ALTERNATIVE WEIGHT
                 ! rt_temp=(abs(rt_new(1:n2*n3)*rt_new(n2*n3+1:)))**.5
                 ! ww(1:n2*n3)=1/((1+rt_temp**2/eps_r**2)**2)
                 ! ww(n2*n3+1:)=ww(1:n2*n3)

                 call sep_write (rt_new,"res_movie")
                 call sep_write (rt_temp,"res")
                 call sep_write (ww(1:n2*n3*2),"wt_movie")
                 ! call sep_write (ww_3D("wt_movie")

                 movie_index=movie_index+1
              end if
           endif irls_if2

           ! APPLY WEIGHT  
!!$           rt_new=rt_new*ww

           ! APPLY EPSILLON
           rt_new(n2*n3+1:)=rt_new(n2*n3+1:)*(eps_h**2)      

           ! APPLY DIVERGENCE
           stat1=igrad2_lop(.true.,.false.,rt_adj2 , rt_new) 


           ! DELTA TAU=FFT[R}
           call dipintegrate_timeslice_full (rt_adj2,dtau,n2,n3,ztrans,eps_h)

           ! STOPPING CRITERION
           res_val_diff=res_val-sqrt(dot_product(rt_new,rt_new))/res_scale
           if (abs(res_val_diff)<stop_tol.and.iter>1) then
              ext_indicator=1
              exit
           else
              ext_indicator=0
           end if
           iteration_counter=iteration_counter+1

           ! UPDATE SOLUTION
           tau=tau+dtau  


           previous_dtau=dot_product(dtau,dtau)


           res_val=sqrt(dot_product(rt_new,rt_new))/res_scale

        end do iterloop2
        tau_3D(it,1:,1:)=reshape(tau,(/n2,n3/))
        !  ww_3D(it,1:,1:,1:)=reshape(ww,(/n2,n3,2/))
        write(0,*) 'iter',iter,'res',sqrt(dot_product(rt_new,rt_new))/res_scale
     end do sliceloop2

     call sep_write(tau_3D) 
     write(0,*) 'EPS_H OUT',eps_h

     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)     
     call to_history ("esize",4)
     call to_history ("d1",   d1)
     call to_history ("d2",   d2)
     call to_history ("d3",   d3)     
     call to_history ("o1",   o1)
     call to_history ("o2",   o2)
     call to_history ("o3",   o3)     
!!$
!!$     call sep_write (ww_3D ,"wt_out") 
!!$     call to_history ("n1",   n1,"wt_out")
!!$     call to_history ("n2",   n2,"wt_out")
!!$     call to_history ("n3",   n3,"wt_out")  
!!$     call to_history ("n4",   2 ,"wt_out")  
!!$     call to_history ("esize",4,"wt_out")

!!$     call to_history ("n1",   n2,"mod_movie")
!!$     call to_history ("n2",   n3,"mod_movie")
!!$     call to_history ("n3",   movie_index,"mod_movie")    
!!$     call to_history ("esize",4,"mod_movie")
!!$
!!$     call to_history ("n1",   n2,"wt_movie")
!!$     call to_history ("n2",   n3*2,"wt_movie")
!!$     call to_history ("n3",   movie_index,"wt_movie")    
!!$     call to_history ("esize",4,"wt_movie")
!!$
!!$     call to_history ("n1",   n2,"res_movie")
!!$     call to_history ("n2",   n3*2,"res_movie")
!!$     call to_history ("n3",   movie_index,"res_movie")    
!!$     call to_history ("esize",4,"res_movie")
!!$
!!$     !   call sep_write (rt_new,"res") 
!!$     call to_history ("n1",   n2,"res")
!!$     call to_history ("n2",   n3*2,"res")
!!$     call to_history ("n3",   movie_index,"res")    
!!$     call to_history ("esize",4,"res")

     write(0,*) 'TOTAL ITERATIONS', iteration_counter
     write(0,*) 'eps_r',eps_r

  case(13)  !Stratigraphic preserved flattening.   dynamically move reference point to flatten as many reflectors as possible.   1D integration----1 slice at a time in time domain using causal integration...fastest theoretically



     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call to_history ("d1",   1)
     call to_history ("d2",   1)
     call to_history ("d3",   1)    
     call to_history ("o1",   0.)
     call to_history ("o2",   0.)
     call to_history ("o3",   0.)   
     allocate(px(n1,n2,1))
     allocate(dtau(n2),tau(n2))
!!$     allocate(tau_2D(n1,n2))
     allocate(hh_2D(n1,n2),px_new(1,n2,1))
     allocate(resid(n2))
     allocate( rt( n2),rt_adj(n2))
     allocate(max_array(1), ref_array(1000000,2),tau_array(1000000,n2))
     allocate(corr_prev_tau(n2),isotau(n2),abs_tau(n2))
     dtau=0.
     tau=0.
     call leakint_2D_init(n1,n2,1.) ! INTEGRATE ALONG X DIRECTION
     call leakint_init (1.)
     call igrad2_2d_init(n1,n2)
     tau=0.
     hh_2D=0.
     do i3=1,n3
        px_new=0.

        call sep_read(px,"dipx")
        ! px_new=px

        !   do it=1,n1
        it=0
        tau_cnt=0
        change_cnt=0
        ist_slice: do while (it<=1)
           it=it+1
           tau=0.
           do iter=1,niter
              call correct_dip_1D  (tau,px,px_new,ref_2,it)
              resid=px_new(1,:,1)
              rt(1:n2)=px_new(1,:,1)
              rt_adj=0.
              rt_adj(2:n2)=rt(1:n2-1)
              rt=rt_adj
              stat1=leakint_lop(.false.,.false.,rt,dtau)
              tau=tau+dtau
           end do

           ! relocate reference trace to lowest point (greatest tau)
           max_array=maxloc(tau)

           if ((ref_2>nint(max_array(1))+1.and.it==1.and.change_cnt<30).or.(ref_2<nint(max_array(1))-1.and.it==1.and.change_cnt<30)) then
              ref_2=nint(max_array(1))
              it=0
              change_cnt=change_cnt+1
              write(0,*) 'reseting ref_2',ref_2,'changes',change_cnt,'it',it
           else 

              ! hh_2D(it,1:)=tau
              tau_cnt=tau_cnt+1
              tau_array(tau_cnt,1:)=tau
              ref_array(tau_cnt,1)=ref_2
              ref_array(tau_cnt,2)=it
              it=2

           end if
        end do ist_slice
        write(0,*) 'finished 1st slice ,ref_2',ref_2


!!$
!!$     call sep_write (tau_array(1:tau_cnt,1:) ,"junk.H") 
!!$     call to_history ("n1",   tau_cnt,"junk.H")
!!$     call to_history ("n2",   n2,"junk.H")
!!$     call to_history ("n3",   1,"junk.H")  
!!$     call to_history ("n4",   1 ,"junk.H")  
!!$     call to_history ("esize",4,"junk.H")



        ir=0
        it=1 
        change_cnt=0
        all_other_slices: do while (it<=n1)
           it=it+1
           tau=0.
           do iter=1,niter
              call correct_dip_1D  (tau,px,px_new,ref_2,it)
              resid=px_new(1,:,1)
              rt(1:n2)=px_new(1,:,1)
              rt_adj=0.
              rt_adj(2:n2)=rt(1:n2-1)
              rt=rt_adj
              stat1=leakint_lop(.false.,.false.,rt,dtau)
              tau=tau+dtau
           end do

           ! correct previous tau for current ref_2
           corr_prev_tau=tau_array(tau_cnt,1:)-tau_array(tau_cnt,ref_2)


!!$     call sep_write (tau-tau(ref_2) ,"junk.H") 
!!$     call to_history ("n1",   n2,"junk.H")
!!$     call to_history ("n2",   1,"junk.H")
!!$     call to_history ("n3",   1,"junk.H")  
!!$     call to_history ("n4",   1 ,"junk.H")  
!!$     call to_history ("esize",4,"junk.H")
!!$stop
           ! compute isochron
           isotau=abs((tau-tau(ref_2))-corr_prev_tau)

!!$  call sep_write (isotau ,"junk.H") 
!!$     call to_history ("n1",   n2,"junk.H")
!!$     call to_history ("n2",   1,"junk.H")
!!$     call to_history ("n3",   1,"junk.H")  
!!$     call to_history ("n4",   1 ,"junk.H")  
!!$     call to_history ("esize",4,"junk.H")
!!$stop

           ! calculate previous tau field in absolute time value
           abs_tau=tau_array(tau_cnt,1:)-tau_array(tau_cnt,nint(ref_array(tau_cnt,1)))+ref_array(tau_cnt,2)

!!$ call sep_write (abs_tau ,"junk.H") 
!!$     call to_history ("n1",   n2,"junk.H")
!!$     call to_history ("n2",   1,"junk.H")
!!$     call to_history ("n3",   1,"junk.H")  
!!$     call to_history ("n4",   1 ,"junk.H")  
!!$     call to_history ("esize",4,"junk.H")


           ! relocate reference trace to thickest point (greatest isotau) but within data
           !    if (minval(abs_tau)>0) then
           !  max_array=maxloc(isotau,abs_tau>0)!.and.abs_tau<=n1)
           max_array=maxloc(isotau,abs_tau>0.and.isotau>2.)
           if (max_array(1)<1.) max_array(1)=ref_2
           !else
           !max_array=ref_2
           !end if
!!$if (maxval(abs_tau)>n1) then
!!$ir=ir+1
!!$ call sep_write (isotau ,"junk.H") 
!!$     call to_history ("n1",   n2,"junk.H")
!!$     call to_history ("n2",   ir,"junk.H")
!!$     call to_history ("n3",   1,"junk.H")  
!!$     call to_history ("n4",   1 ,"junk.H")  
!!$     call to_history ("esize",4,"junk.H")

           write(0,*) 'max_array loc',max_array
!!$stop
!!$end if
!!$write(0,*) change_cnt
!!$if (change_cnt>3) stop
           if ((ref_2>nint(max_array(1))+3.and.change_cnt<1).or.(ref_2<nint(max_array(1))-3.and.change_cnt<1)) then
              ref_2=nint(max_array(1))

              write(0,*) 'reseting ref_2',ref_2

              ! look up previous slice at new reference trace
              prev_tau_val=abs_tau(ref_2)

              write(0,*) 'prev_tau_val',prev_tau_val


              it=floor(prev_tau_val)
              change_cnt=change_cnt+1
              write(0,*) 'reseting ref_2',ref_2,'changes',change_cnt,'it',it
              !stop
           else 
              !hh_2D(it,1:)=tau
              tau_cnt=tau_cnt+1
              tau_array(tau_cnt,1:)=tau
              ref_array(tau_cnt,1)=ref_2
              ref_array(tau_cnt,2)=it
              !it=it+1
              change_cnt=0
              !if (tau_cnt>250) exit
              write(0,*) 'writing out a tau at tau_cnt',tau_cnt,'ref_2',ref_2,'it',it
           end if
        end do all_other_slices

        !once it=n1 then locate highest spot on tau and walk down.







        write(0,*) 'finished all slices '




        call sep_write (tau_array(1:tau_cnt,1:)) !-sum(hh_2D(1:n1,1:n2))/(n1*n2)) 
        call to_history ("n1",   tau_cnt)

        call sep_write (ref_array(1:tau_cnt,1:),"ref") 
        call to_history ("n1",   tau_cnt,"ref")
        call to_history ("n2",   2,"ref")
        call to_history ("n3",   1,"ref")  
        call to_history ("n4",   1 ,"ref")  
        call to_history ("esize",4,"ref")




     end do

  case(14)  ! 2D integration----1 slice at a time but proper regularization

     allocate(ztrans(2*n1,2*n2,1),px(n1,n2,1))
     call z_trans(2*n1,2*n2,1,eps_t**2,0.,ztrans)


     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call to_history ("d1",   1)
     call to_history ("d2",   1)
     call to_history ("d3",   1)    
     call to_history ("o1",   0.)
     call to_history ("o2",   0.)
     call to_history ("o3",   0.)   
     allocate(dtau(n1*n2*1),tau(n1*n2*1),tau2D(n1,n2))
     allocate(hh_2D(n1,n2),px_new(n1,n2,2),px_dat(n1,n2,1))
     allocate(resid(n1*n2*2))
     allocate( rt( n1*n2*2))
     allocate(tau_grad(n1,n2))
     dtau=0.
     tau=0.
     tau_grad=0.
     px_new=0.

     do it=1,n3
        call sep_read(px,"dipx")
        !px(1:60,1:,1)=0.
        !px(110:,1:,1)=0.
        px_new(1:,1:,2)=px(1:,1:,1)
        !px_new(1:80,1:,2)=0.
        write(0,*) maxval(px),minval(px),sum(px)/size(px)
        rt=0.
        hh=0.
        tau=0.
        dtau=0.
        do iter=1,niter
           !  allocate( rt( n1*n2))
           rt(1:n1*n2*2)=reshape(px_new,(/size(px_new)/))

           call dipintegrate_2D_reg (rt,dtau,eps_t,n1,n2,ztrans) 
!     call dipintegrate_2D_fftw3 (rt,dtau,eps_t,n1,n2,ztrans) 


           !     tau=tau+dtau

           ! contraints
!!$           tau2D=reshape(dtau,(/n1,n2/))
!!$           tau2D(50:80,1:)=0.
!!$
!!$           ! tau2D(168,1:)=0.
!!$           dtau=reshape(tau2D,(/n1*n2/))

           tau=tau+dtau
           write(0,*) maxval(px_new)   

           call correct_dip_2D  (tau,px,px_dat,ref_2)

           ! CALCULATE MODEL RESIDUAL
           tau2D=reshape(tau,(/n1,n2/))
           tau_grad=0.
           do i= 1, n1-1 
              do j= 1, n2-1 
                 tau_grad(i,j)= tau_grad(i,j)+( tau2D(i+1,j) - tau2D(i,j)) 
              end do
           end do
           px_new(1:,1:,1)=-eps_t*tau_grad(1:,1:)
           !px_new(1:,1:,1)=0.
           px_new(1:,1:,2)=px_dat(1:,1:,1)
           !px_new(1:80,1:,2)=0.
           write(0,*) maxval(px_new)   
           !  call dipintegrate_3D_slice (rt,hh,eps_t,eps_h,1,n1,n2,ztrans)

           resid=reshape(px_new,(/n1*n2*2/))

           ! contraints
           !tau2D=reshape(px_new,(/n1,n2/))
           !tau2D(1:50,1:)=0.
           !px_new(1:50,1:,1)=0.
           !px_new(160,1:,1)=0.

           write(0,*) 'iter',iter,'residual',dot_product(resid,resid)
           call sep_write (tau,"mod_movie")
           call sep_write (px_new,"res_movie")
        end do

        hh_2D=reshape(tau,(/n1,n2/))


        call sep_write (hh_2D(1:n1,1:n2)) !-sum(hh_2D(1:n1,1:n2))/(n1*n2)) 
     end do

     !DELETE !!!
     do it=1,n1
        hh_2D(it,1:)=it
     end do
!!$     call sep_write (hh_2D(1:n1,1:n2),"junk")
!!$     call to_history ("n1",   n1,"junk")
!!$     call to_history ("n2",   n2,"junk")

     call to_history ("n1",   n1,"mod_movie")
     call to_history ("n2",   n2,"mod_movie")
     call to_history ("n3",   niter,"mod_movie")    
     call to_history ("esize",4,"mod_movie")

     call to_history ("n1",   n1,"res_movie")
     call to_history ("n2",   n2*2,"res_movie")
     call to_history ("n3",   niter,"res_movie")    
     call to_history ("esize",4,"res_movie")

  case(15)  ! 2D integration----1 slice at a time but proper regularization using conjagate gradients with a model mask

     allocate(ztrans(2*n1,2*n2,1),px(n1,n2,1))
     call z_trans(2*n1,2*n2,1,eps_t**2,0.,ztrans)


     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
  call to_history ("d1",d1)
  call to_history ("d2",d2)
  call to_history ("d3",d3)
  call to_history ("o1",o1)
  call to_history ("o2",o2)
  call to_history ("o2",o3)

     allocate(dtau(n1*n2*1),tau(n1*n2*1),tau2D(n1,n2))
     allocate(hh_2D(n1,n2),px_new(n1,n2,2),px_dat(n1,n2,1))
     allocate(resid(n1*n2*2))
     allocate( rt( n1*n2*2))
     allocate(tau_grad(n1,n2))
     allocate(model_mask_2d(n1,n2),model_mask_1d(n1*n2),initial_model(n1*n2),initial_model_2d(n1,n2))
     dtau=0.
     tau=0.
     tau_grad=0.
     px_new=0.
     initial_model=0.

     model_mask_2d=1.
     !    model_mask_2d(60:80,1:)=0.
 !   model_mask_2d(70,1:)=0.
 !   model_mask_2d(110,1:)=0.
     model_mask_1d=reshape(model_mask_2d,(/size(model_mask_1d)/))
     call igrad2_2d_reg_init(n1,n2,eps_t)
     call igrad2_init(n1,n2)
     call igrad1_2d_off_init(n1,n2)
     call eps_weight_init(n1,n2,eps_t)
!     call model_mask_init(n1,n2,model_mask_1d)
     write(0,*) 'eps',eps_t
     if (exist_file("initial_model")) call sreed("initial_model", initial_model,4*n1*n2)


initial_model_2d=reshape(initial_model,(/n1,n2/))
initial_model_2d(1:69,1:)=0.
  initial_model_2d(71:109,1:)=0.
 initial_model_2d(111:,1:)=0.
initial_model=reshape(initial_model_2d,(/n1*n2/))
    initial_model=0.
     call sep_read(px,"dipx")

     do it=1,n3
        call sep_read(px,"dipx")
        !        px(1:60,1:,1)=0.
        !        px(110:,1:,1)=0.
        px_new(1:,1:,2)=px(1:,1:,1)
        !px_ew(1:80,1:,2)=0.
        write(0,*) maxval(px),minval(px),sum(px)/size(px)
        rt=0.
        hh=0.
        tau=0.
        dtau=0.
        do iter=1,niter
           !  allocate( rt( n1*n2))
           rt(1:n1*n2*2)=reshape(px_new,(/size(px_new)/))

           !call dipintegrate_2D_reg (rt,dtau,eps_t,n1,n2,ztrans) 
           !      call solver_smp(dtau, rt,igrad2_2d_reg_lop,cgstep,linear_niter,verb=.true.)
           !  call solver_smp(dtau, rt,igrad2_lop,cgstep,linear_niter,verb=.true.,Wop=eps_weight_lop)
           ! call solver_smp(dtau, rt,igrad1_2d_lop,cgstep,linear_niter,verb=.true.)

if (iter==1) then
! call solver_smp(dtau, rt,igrad2_2d_reg_lop,cgstep,linear_niter,verb=.true.,Jop=model_mask_lop,m0=initial_model)
else 
! call solver_smp(dtau, rt,igrad2_2d_reg_lop,cgstep,linear_niter,verb=.true.,Jop=model_mask_lop)
end if
           !     tau=tau+dtau

           ! contraints
!!$           tau2D=reshape(dtau,(/n1,n2/))
!!$           tau2D(50:80,1:)=0.
!!$
!!$           ! tau2D(168,1:)=0.
!!$           dtau=reshape(tau2D,(/n1*n2/))

           tau=tau+dtau
           write(0,*) maxval(px_new)   

           call correct_dip_2D  (tau,px,px_dat,ref_2)

           ! CALCULATE MODEL RESIDUAL
           tau2D=reshape(tau,(/n1,n2/))
           tau_grad=0.
           do i= 1, n1-1 
              do j= 1, n2-1 
                 tau_grad(i,j)= tau_grad(i,j)+( tau2D(i+1,j) - tau2D(i,j)) 
              end do
           end do
           px_new(1:,1:,1)=-eps_t*tau_grad(1:,1:)
           !px_new(1:,1:,1)=0.
           px_new(1:,1:,2)=px_dat(1:,1:,1)
           !px_new(1:80,1:,2)=0.
           write(0,*) maxval(px_new)   
           !  call dipintegrate_3D_slice (rt,hh,eps_t,eps_h,1,n1,n2,ztrans)

           resid=reshape(px_new,(/n1*n2*2/))

           ! contraints
           !tau2D=reshape(px_new,(/n1,n2/))
           !tau2D(1:50,1:)=0.
           !px_new(1:50,1:,1)=0.
           !px_new(160,1:,1)=0.

           write(0,*) 'iter',iter,'residual',dot_product(resid,resid)
           call sep_write (tau,"mod_movie")
           call sep_write (px_new,"res_movie")
        end do

        hh_2D=reshape(tau,(/n1,n2/))


        call sep_write (hh_2D(1:n1,1:n2)) !-sum(hh_2D(1:n1,1:n2))/(n1*n2)) 
     end do

     !DELETE !!!
     do it=1,n1
        hh_2D(it,1:)=it
     end do
!!$     call sep_write (hh_2D(1:n1,1:n2),"junk")
!!$     call to_history ("n1",   n1,"junk")
!!$     call to_history ("n2",   n2,"junk")

     call to_history ("n1",   n1,"mod_movie")
     call to_history ("n2",   n2,"mod_movie")
     call to_history ("n3",   niter,"mod_movie")    
     call to_history ("esize",4,"mod_movie")

     call to_history ("n1",   n1,"res_movie")
     call to_history ("n2",   n2*2,"res_movie")
     call to_history ("n3",   niter,"res_movie")    
     call to_history ("esize",4,"res_movie")

!!$ case(16)  ! SAME AS CASE 14 BUT USING COS TRANSFORMS 2D integration----1 slice at a time but proper regularization
!!$
!!$     allocate(cos_trans(2*n1,2*n2,1),px(n1,n2,1))
!!$     !call z_trans(2*n1,2*n2,1,eps_t**2,0.,ztrans)
!!$     call cos_trans(2*n1,2*n2,1,eps_t**2,0.,cos_trans)
!!$
!!$     call to_history ("n1",   n1)
!!$     call to_history ("n2",   n2)
!!$     call to_history ("n3",   n3)    
!!$     call to_history ("esize",4)
!!$     call to_history ("d1",   1)
!!$     call to_history ("d2",   1)
!!$     call to_history ("d3",   1)    
!!$     call to_history ("o1",   0.)
!!$     call to_history ("o2",   0.)
!!$     call to_history ("o3",   0.)   
!!$     allocate(dtau(n1*n2*1),tau(n1*n2*1),tau2D(n1,n2))
!!$     allocate(hh_2D(n1,n2),px_new(n1,n2,2),px_dat(n1,n2,1))
!!$     allocate(resid(n1*n2*2))
!!$     allocate( rt( n1*n2*2))
!!$     allocate(tau_grad(n1,n2))
!!$     dtau=0.
!!$     tau=0.
!!$     tau_grad=0.
!!$     px_new=0.
!!$
!!$     do it=1,n3
!!$        call sep_read(px,"dipx")
!!$        !px(1:60,1:,1)=0.
!!$        !px(110:,1:,1)=0.
!!$        px_new(1:,1:,2)=px(1:,1:,1)
!!$        !px_new(1:80,1:,2)=0.
!!$        write(0,*) maxval(px),minval(px),sum(px)/size(px)
!!$        rt=0.
!!$        hh=0.
!!$        tau=0.
!!$        dtau=0.
!!$        do iter=1,niter
!!$           !  allocate( rt( n1*n2))
!!$           rt(1:n1*n2*2)=reshape(px_new,(/size(px_new)/))
!!$
!!$           call dipintegrate_2D_reg (rt,dtau,eps_t,n1,n2,ztrans) 
!!$
!!$
!!$
!!$           !     tau=tau+dtau
!!$
!!$           ! contraints
!!$           tau2D=reshape(dtau,(/n1,n2/))
!!$           tau2D(50:80,1:)=0.
!!$
!!$           ! tau2D(168,1:)=0.
!!$           dtau=reshape(tau2D,(/n1*n2/))
!!$
!!$           tau=tau+dtau
!!$           write(0,*) maxval(px_new)   
!!$
!!$           call correct_dip_2D  (tau,px,px_dat,ref_2)
!!$
!!$           ! CALCULATE MODEL RESIDUAL
!!$           tau2D=reshape(tau,(/n1,n2/))
!!$           tau_grad=0.
!!$           do i= 1, n1-1 
!!$              do j= 1, n2-1 
!!$                 tau_grad(i,j)= tau_grad(i,j)+( tau2D(i+1,j) - tau2D(i,j)) 
!!$              end do
!!$           end do
!!$           px_new(1:,1:,1)=-eps_t*tau_grad(1:,1:)
!!$           !px_new(1:,1:,1)=0.
!!$           px_new(1:,1:,2)=px_dat(1:,1:,1)
!!$           !px_new(1:80,1:,2)=0.
!!$           write(0,*) maxval(px_new)   
!!$           !  call dipintegrate_3D_slice (rt,hh,eps_t,eps_h,1,n1,n2,ztrans)
!!$
!!$           resid=reshape(px_new,(/n1*n2*2/))
!!$
!!$           ! contraints
!!$           !tau2D=reshape(px_new,(/n1,n2/))
!!$           !tau2D(1:50,1:)=0.
!!$           !px_new(1:50,1:,1)=0.
!!$           !px_new(160,1:,1)=0.
!!$
!!$           write(0,*) 'iter',iter,'residual',dot_product(resid,resid)
!!$           call sep_write (tau,"mod_movie")
!!$           call sep_write (px_new,"res_movie")
!!$        end do
!!$
!!$        hh_2D=reshape(tau,(/n1,n2/))
!!$
!!$
!!$        call sep_write (hh_2D(1:n1,1:n2)) !-sum(hh_2D(1:n1,1:n2))/(n1*n2)) 
!!$     end do
!!$
!!$     !DELETE !!!
!!$     do it=1,n1
!!$        hh_2D(it,1:)=it
!!$     end do
!!$     call sep_write (hh_2D(1:n1,1:n2),"junk")
!!$     call to_history ("n1",   n1,"junk")
!!$     call to_history ("n2",   n2,"junk")
!!$
!!$     call to_history ("n1",   n1,"mod_movie")
!!$     call to_history ("n2",   n2,"mod_movie")
!!$     call to_history ("n3",   niter,"mod_movie")    
!!$     call to_history ("esize",4,"mod_movie")
!!$
!!$     call to_history ("n1",   n1,"res_movie")
!!$     call to_history ("n2",   n2*2,"res_movie")
!!$     call to_history ("n3",   niter,"res_movie")    
!!$     call to_history ("esize",4,"res_movie")
  end select


end program Dipintegrator_3D_2











