program Dipintegrator_chev
  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  !use dipinteg_3D
  !use dipinteg_3D_slice
  !  use igrad3_period 
  use ztrans_mod
  use dipinteg_3D_2
  use triangle
  use igrad1
  use igrad2_2d
  use igrad2_3d
  use igrad1_3d
  use igrad1_2d
  use igrad3
  use icai1
  use igrad2
  use leakint_2D
  use leakint2
  use leakint
  use dottest
  use igrad3_epst
  use fault_weight
  use solver_smp_mod
  use weight_solver

  ! use triangle1

  implicit none
  integer 	                             :: n1, n2, n3, iter,mirror,bounds,slice,esize,stat1,iv,ik,min_niter
  integer                                    ::padlength,it,ix,iy,ir,dist,taper_len,niter,ip,irls_index,i3
  integer                                    ::linear_niter,movie_index,use_wt
  integer                                    ::ref_2,ref_3,irls,slice_width
  integer                                    ::i1,ext_indicator,iteration_counter
  integer                                    ::max_index,tau_cnt,change_cnt,method
  real                                       :: q,eps_t,eps_h,pi_var,eps_r,wt_iter
  real                                       ::d1,d2,d3,o1,o2,o3,previous_dtau
  real                                       ::res_scale,res_val,last_res,res_val_diff
  real                                       ::prev_tau_val
  complex, dimension (:,:,:),   allocatable  :: data_in
  complex, dimension (:,:,:),   allocatable    ::ztrans,ztrans2
  real,    dimension (:),     allocatable    :: cos_wt,resid,rand_vec,rt_full,ww_bounds,ww_bounds_temp,max_array
  real,    dimension (:),     allocatable    ::corr_prev_tau,isotau, abs_tau
  real,    dimension(:),pointer              ::rt,hh,dtau,tau,tau_1st,tau_2nd,rt_new,rt_temp
  real,    dimension (:,:),     allocatable  ::hh_2D,tau_slice,ref_array,tau_array
  real,    dimension (:,:),     allocatable  ::tau_2D,ww_2D_bounds
  real,    dimension (:,:,:),   allocatable  :: data_amp,data_phz,data_real
  real,    dimension (:,:,:),   allocatable  :: data_imag,px,py,px_mirr,px_new
  real,    dimension (:,:,:),   allocatable  :: py_mirr,hh_3D
  real,    dimension (:,:,:),   allocatable  :: hh_3D_trun,tau_3D,res_3D,rt_3D
  real,    dimension (:,:,:,:),   allocatable  ::ww_3D,ww_3D_bounds
  !TEMPORY PTERM STUFF
  real,    dimension (:,:), allocatable      ::p_sqr,p_sqr_dtau,p_sqr_dtau_sm,pterm_cor
  real,    dimension(:),pointer              ::rt_adj,pterm_cor_1D,filter,ww,res_div,res_rev,rt_adj2
  real,    dimension(:),allocatable           ::ww_slice
  integer, dimension (2)                :: n, rect
  real,    dimension  (2)   :: dot1,dot2
  real                                 ::upwt,downwt,p_tau_x,p_tau_y,stop_tol
  integer                                ::tau_1,tau_2
  real                                 ::dtau_dx,dtau_dy,shift_var
  real,    dimension (:,:), allocatable      ::px_2D_new,py_2D_new
  real,    dimension (:,:,:),   allocatable  ::px_3D,py_3D
  real,    dimension (:,:,:),   allocatable  ::p_sqr2,thrd_trm
  real,    dimension (:),   allocatable  ::p_sqr2_1D,thrd_trm_1D,thrd_trm_int
  real,    dimension(:), allocatable         ::tau_sample
  real,    dimension(:,:,:), allocatable         ::tau_sample_3D
  ! TEMPORARY VARIABLES
  real,    dimension (:), allocatable        ::dip_diff,dip_integ,px_1D
  real,    dimension (:,:), allocatable      ::dip_integ2D,dip_correction
  integer                                    ::iz
  call sep_init ()

  call from_param("eps_t",eps_t,1.)
  call from_param("eps_h",eps_h,1.)
  call from_param("eps_r",eps_r,1.)
  call from_param("mirror",mirror,1) 
  call from_param("method",method,1)
  call from_param("ref_2",ref_2,1)
  call from_param("ref_3",ref_3,1)
  call from_aux ("dipx", n1,n2,n3,esize=4)
  call from_history ("dipx",d1,1.)
  call from_history ("dipx",d2,1.)
  call from_history ("dipx",d3,1.)
  call from_history ("dipx",o1,0.)
  call from_history ("dipx",o2,0.)
  call from_history ("dipx",o3,0.)


  write(0,*) 'n1,n2,n3',n1,n2,n3
  call from_param("niter",niter,1)
  call from_param("min_niter",min_niter,1)
  call from_param("linear_niter",linear_niter,100)
  call from_param("wt_iter",wt_iter,1.)
  call from_param("irls",irls,0)
  call from_param("stop_tol",stop_tol,.0001)



  select case(method)


  case(0)  ! 1D integration----1 slice at a time in time domain using causal integration...fastest theoretically

     allocate(ztrans(n1,2*n2,1),px(n1,n2,1))
     call z_trans(n1,2*n2,1,eps_t,0.,ztrans)


     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)    
     call to_history ("esize",4)
     call to_history ("d1",   1)
     call to_history ("d2",   1)
     call to_history ("d3",   1)    
     call to_history ("o1",   0.)
     call to_history ("o2",   0.)
     call to_history ("o3",   0.)   
     allocate(dtau(n1*n2*1),tau(n1*n2*1))
     allocate(tau_2D(n1,n2))
     allocate(hh_2D(n1,n2),px_new(n1,n2,1))
     allocate(resid(n1*n2*1))
     allocate( rt( n1*n2),rt_adj(n1*n2))
     allocate(tau_sample(n1*n2))
     allocate(tau_sample_3D(n1,n2,1))
     allocate(p_sqr2(n1,n2,1),thrd_trm(n1,n2,1))
     allocate(p_sqr2_1D(n1*n2*1),thrd_trm_1D(n1*n2*1),thrd_trm_int(n1*n2*1))


     dtau=0.
     tau=0.

     call leakint_2D_init(n1,n2,1.) ! INTEGRATE ALONG X DIRECTION
     call leakint_init (1.)
     call igrad2_2d_init(n1,n2)


     do it=1,n3
        px_new=0.
        call sep_read(px,"dipx")
        px_new=px
        hh=0.
        dtau=0.
        rt(1:n1*n2)=reshape(px_new,(/n1*n2/))
        res_scale=max(1.,sqrt(dot_product(rt,rt)))
        res_val=1. !res_scale   
        do iter=1,niter
           call correct_dip_2D  (tau,px,px_new,ref_2)
           resid=reshape(px_new,(/n1*n2*1/))
           ! STOPPING CRITERION
           res_val_diff=res_val-sqrt(dot_product(resid,resid))/res_scale
           !          if (dot_product(resid,resid)/(n1*n2)<stop_tol.and.iter>=min_niter) exit

           if (abs(res_val_diff)<stop_tol.and.iter>1.and.iter>=min_niter) exit 

           rt(1:n1*n2)=reshape(px_new,(/size(px)/))
           rt_adj=0.
           rt_adj(n1+1:n1*n2)=rt(1:n1*n2-n1)
           rt=rt_adj
           stat1=leakint_2D_lop(.false.,.false.,rt,dtau)
           tau=tau+dtau
           res_val=sqrt(dot_product(rt,rt))/res_scale
        end do
        write(0,*) 'gather',it,'of',n3,'iter',iter,'residual',res_val
        hh_2D=reshape(tau,(/n1,n2/))
        call sep_write (hh_2D(1:n1,1:n2)) !-sum(hh_2D(1:n1,1:n2))/(n1*n2)) 
     end do






  case(1) !one slice at a time for 3D volumes
     allocate(px(n1,n2,n3),py(n1,n2,n3))
     write(0,*) 'READ IN THE DIPS'
     call sep_read(px,"dipx")
     call sep_read(py,"dipy")
     allocate(ztrans(1,2*n2,2*n3))
     ! PRECOMPUTE ZTRANS OF LAPLACIAN
     call z_trans(1,2*n2,2*n3,0.,eps_h**2,ztrans)
     allocate( rt( n2*n3*2),rt_new(n2*n3*2),tau_3D(n1,n2,n3),tau(n2*n3))
     allocate(dtau(n2*n3))
!!$     allocate(rt_full(n1*n2*n3*2))     
     allocate(tau_2D(n2,n3))
     allocate(px_2D_new(n2,n3),py_2D_new(n2,n3))
     allocate(px_3D(n1,n2,n3),py_3D(n1,n2,n3))
!!$     allocate(ww(n2*n3*2),ww_3D(n1,n2,n3,2),ww_bounds(n2*n3*2),ww_2D_bounds(n2,n3*2))
!!$     allocate(ww_bounds_temp(n2*n3*2))
     allocate(rt_adj2(n2*n3)) !,resid(n2*n3*2))

!!$     ! CREATE WEIGHT BOUNDS
!!$     ww_2D_bounds=1.
!!$     ww_2D_bounds(n2,1:)=0.
!!$     ww_2D_bounds(1:,n3)=0.
!!$     ww_2D_bounds(1:,2*n3)=0.
!!$
!!$     ww_bounds=reshape(ww_2D_bounds,(/n2*n3*2/))

     py=py
     px_3D=px
     py_3D=py
     tau=0.
     !last_res=res_val
     ww=1.
     ww_3D=1.
     movie_index=0
!!$     if (exist_file("wt_in")) then 
!!$        write(0,*) 'READING IN WEIGHT'
!!$        call sreed("wt_in",ww_3D,4*n1*n2*n3*1)
!!$        px_3D=px_3D*ww_3D(1:,1:,1:,1)
!!$        py_3D=py_3D*ww_3D(1:,1:,1:,1) 
!!$        write(0,*) 'READ IN WEIGHT'
!!$        use_wt=0
!!$     end if
     iteration_counter=0

     sliceloop: do it=1,n1,1 
        previous_dtau=0.

        write(0,*) 'grabbing slice',it,'of',n1,(real(it)/real(n1))*100.,'% complete'
        rt=0.
        hh=0.
!!$        ww=1.

        rt(1:n2*n3)        =reshape(px(it,1:,1:),(/n2*n3/))
        rt(n2*n3+1:n2*n3*2)=reshape(py(it,1:,1:),(/n2*n3/))
        !     end if
        rt_new=rt

!!$        if (exist_file("wt_in")) then
!!$           write(0,*) 'READING IN WEIGHT'
!!$
!!$           ww(1:n2*n3)        =reshape(ww_3D(it,1:,1:,1),(/n2*n3/))
!!$           ww(n2*n3+1:2*n2*n3)=reshape(ww_3D(it,1:,1:,1),(/n2*n3/))  
!!$           rt_new=rt_new*ww
!!$        end if


        res_scale=max(1.,sqrt(dot_product(rt_new,rt_new)))
        res_val=1. !res_scale


        call igrad2_init(n2,n3)

        iterloop: do iter=1,niter

           tau_2D=reshape(tau,(/n2,n3/))
           px_2D_new=0.  ! 
           py_2D_new=0.


           ! P - GRAD TAU  =R 
           do ix=1,n2-1
              do iy=1,n3-1
                 shift_var=tau_2D(ix,iy)-tau_2D(ref_2,ref_3)
                 tau_1=floor(it+shift_var)
                 tau_2=ceiling(it+shift_var)
                 upwt=it+shift_var-tau_1
                 downwt=1.-upwt

                 if (tau_1>=1.AND.tau_2<=n1) then
                    p_tau_x=downwt*px_3D(tau_1,ix,iy)+upwt*px_3D(tau_2,ix,iy)
                    p_tau_y=downwt*py_3D(tau_1,ix,iy)+upwt*py_3D(tau_2,ix,iy)

                    dtau_dx=tau_2D(ix+1,iy)-tau_2D(ix,iy)
                    dtau_dy=tau_2D(ix,iy+1)-tau_2D(ix,iy)

                    px_2D_new(ix,iy)=p_tau_x-dtau_dx
                    py_2D_new(ix,iy)=(p_tau_y-dtau_dy)   !*eps_h**2
                 end if
              end do
           end do

           rt_new(1:n2*n3)=reshape(px_2D_new,(/n2*n3/))
           rt_new(n2*n3+1:2*n2*n3)=reshape(py_2D_new,(/n2*n3/))

           ! IRLS STUFF COMPUTE  W=1/1+RESIDUAL...
           !res_val_diff=res_val-sqrt(dot_product(rt_new,rt_new))/res_scale
!!$           irls_if: if (irls==1) then
!!$              if (real(iter)/wt_iter-floor(real(iter)/wt_iter)<.00001) then
!!$                 ! if (abs(res_val_diff)<stop_tol.and.iter>1.and.irls==1) then
!!$                 write(0,*) 'REWEIGHTING', iter
!!$                 if (real(iter)/1000-floor(real(iter)/1000)<.00001) eps_r=eps_r*.8
!!$                 ww=1/(1+rt_new**2/eps_r**2)**2
!!$                 ww=ww*ww_bounds
!!$               
!!$                 call sep_write (rt_new,"res_movie")
!!$                 call sep_write (ww(1:n2*n3*2),"wt_movie")
!!$                 ! call sep_write (ww_3D("wt_movie")
!!$
!!$                 movie_index=movie_index+1
!!$              end if
!!$           endif irls_if

           ! APPLY WEIGHT  
!!$           rt_new=rt_new*ww

           ! APPLY EPSILLON
           rt_new(n2*n3+1:)=rt_new(n2*n3+1:)*(eps_h**2)      

           ! APPLY DIVERGENCE
           stat1=igrad2_lop(.true.,.false.,rt_adj2 , rt_new) 


           ! DELTA TAU=FFT[R}
           call dipintegrate_timeslice_full (rt_adj2,dtau,n2,n3,ztrans,eps_h)

           ! STOPPING CRITERION
           res_val_diff=res_val-sqrt(dot_product(rt_new,rt_new))/res_scale
           if (abs(res_val_diff)<stop_tol.and.iter>1.and.iter>=min_niter) then
              ext_indicator=1
              exit
           else
              ext_indicator=0
           end if
           iteration_counter=iteration_counter+1

           ! UPDATE SOLUTION
           tau=tau+dtau  


           previous_dtau=dot_product(dtau,dtau)


           res_val=sqrt(dot_product(rt_new,rt_new))/res_scale

        end do iterloop
        tau_3D(it,1:,1:)=reshape(tau,(/n2,n3/))
!!$        ww_3D(it,1:,1:,1:)=reshape(ww,(/n2,n3,2/))
        write(0,*) 'iter',iter,'res',sqrt(dot_product(rt_new,rt_new))/res_scale
     end do sliceloop

     call sep_write(tau_3D) 
     write(0,*) 'EPS_H OUT',eps_h

     call to_history ("n1",   n1)
     call to_history ("n2",   n2)
     call to_history ("n3",   n3)     
     call to_history ("esize",4)
     call to_history ("d1",   d1)
     call to_history ("d2",   d2)
     call to_history ("d3",   d3)     
     call to_history ("o1",   o1)
     call to_history ("o2",   o2)
     call to_history ("o3",   o3)     

!!$     call sep_write (ww_3D ,"wt_out") 
!!$     call to_history ("n1",   n1,"wt_out")
!!$     call to_history ("n2",   n2,"wt_out")
!!$     call to_history ("n3",   n3,"wt_out")  
!!$     call to_history ("n4",   2 ,"wt_out")  
!!$     call to_history ("esize",4,"wt_out")

!!$     call to_history ("n1",   n2,"mod_movie")
!!$     call to_history ("n2",   n3,"mod_movie")
!!$     call to_history ("n3",   movie_index,"mod_movie")    
!!$     call to_history ("esize",4,"mod_movie")
!!$
!!$     call to_history ("n1",   n2,"wt_movie")
!!$     call to_history ("n2",   n3*2,"wt_movie")
!!$     call to_history ("n3",   movie_index,"wt_movie")    
!!$     call to_history ("esize",4,"wt_movie")
!!$
!!$     call to_history ("n1",   n2,"res_movie")
!!$     call to_history ("n2",   n3*2,"res_movie")
!!$     call to_history ("n3",   movie_index,"res_movie")    
!!$     call to_history ("esize",4,"res_movie")
!!$
!!$     !   call sep_write (rt_new,"res") 
!!$     call to_history ("n1",   n2,"res")
!!$     call to_history ("n2",   n3*2,"res")
!!$     call to_history ("n3",   movie_index,"res")    
!!$     call to_history ("esize",4,"res")

     write(0,*) 'TOTAL ITERATIONS', iteration_counter
     write(0,*) 'eps_r',eps_r




  end select


end program Dipintegrator_chev











