program LMO
  ! create simple dip field for flattening of input space of straight reflectors
  !
  use sep

  implicit none
  integer 	                          :: n1, n2, n3, i1,i2,i3,ref_2
  real,    dimension (:,:,:),   allocatable :: dat,tau

  call sep_init ()
  call from_history (n1,n2,n3,esize=4)
  call to_history ("esize",4)
 call from_param("ref_2",ref_2,n2/2) !locate of the reference trace on the 2-axis
  write(0,*) n1,n2,n3


  allocate (tau(n1,n2,n3))          


  write(0,*) 'n1/n2/n3',n1,n2,n3


  !take each point in the section and calculate a dip
  do i3=1,n3
     do i2=1,n2
        do i1=1,n1      
   tau(i1,i2,i3)=(i1*i2)/(i2*i2+.00001)
if (tau(i1,i2,i3)>2) tau(i1,i2,i3)=2
        end do
     end do
  end do

  call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  call sep_write (tau) 

!!$  call to_history("n1",n1,"outwt"); call to_history("n2",n2,"outwt")
!!$  call to_history("n3",n3,"outwt")
!!$  call to_history("d1",1.0,"outwt"); call to_history("d2",1.0,"outwt")
!!$  call to_history("d3",1.0,"outwt")
!!$  call to_history("o1",0.,"outwt"); call to_history("o2",0.,"outwt")
!!$  call to_history("o3",0.,"outwt")
!!$  call to_history("esize",4,"outwt")
!!$  call sep_write(outwt,"outwt")	
!!$




  deallocate (tau)
  call sep_close()
  call exit (0)
end program LMO














