program Precon_3D
  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  !  use dipinteg_3D
  !  use dipinteg_precond
  use igrad3_period 
  !  use change_jl
  use fault_weight
  use igrad2
  use igrad3_epst
  use chain_mod
  use prec_oper
  ! use cgstep_jesse_mod
  use cgstep_wrt_mod 
  use polydiv
  use lapfac
  use lapfac3
  use solver_prc_mod
  use solver_smp_jesse_3D_mod

  implicit none
  integer 	                             :: n1, n2, n3, iter,mirror,bounds,slice,k,k_max,niter
  integer                                    ::padlength,it,ix,iy,ir,dist,taper_len,stat1,stat2 
  integer                                    ::method,na
  real                                       :: q,eps_t,eps_h,pi_var,beta,alpha,epsi
  double precision     :: alpha_new,beta_new
  complex, dimension (:,:,:),   allocatable  :: data_in
  complex, dimension (:,:),   allocatable    ::ztrans
  real,    dimension (:),     allocatable    :: cos_wt,res_out,err_out
  real,    dimension(:),pointer              ::rt,hh,Fop,ww,tmp1,tmp2,rt_adj,tmp3,rt_wt,rd_jes
  real,    dimension (:,:),   allocatable  ::hh_2D,tau,r,z,p
  real,    dimension (:),   allocatable      ::s,BigR,BigS,g,BigG,init_m
  real,    dimension (:,:,:),   allocatable  :: data_amp,data_phz,data_real
  real,    dimension (:,:,:),   allocatable  :: data_imag,px,py,px_mirr,outwt
  real,    dimension (:,:,:),   allocatable  :: py_mirr,hh_3D
  real,    dimension (:,:,:),   allocatable  :: hh_3D_trun,tau_3d
  real,    dimension  (2)   :: dot1,dot2
  type(filter)      :: aa
  logical ::forget
  call sep_init ()
  call from_aux ("dipx", n1,n2,n3,esize=4)
  call from_param("eps_t",eps_t,1.)
  call from_param("eps_h",eps_h,1.)
  call from_param("mirror",mirror,1)
  call from_param("bounds",bounds,1)
  call from_param("slice",slice,0)

  call from_param("method",method,3)
  call from_param("niter",niter,10)

  write(0,*) 'about to allocate 1'
  allocate(data_in(n1,n2,n3),px(n1,n2,n3),py(n1,n2,n3))
  write(0,*) 'successfully allocated'

  call sep_read(px,"dipx")
  call sep_read(py,"dipy")

eps_t=0.

  ! CREATE PI VARIABLE
  pi_var=acos(-1.)





  allocate(hh(n1*n2*n3))
!!$  allocate(hh_2D(n1,n2))


  !  allocate( ztrans3d(n1,2*n2,2*n3))
  allocate(outwt(n1,n2,n3),ww((n1)*(n2)*(n3)*3))
  ! call z_trans(2*n1,2*n2,ztrans)
  outwt=1. 
  if (exist_file("wt")) call sreed("wt", outwt,4*n1*n2*n3)
  ww=0.
  ww(1:(n1)*(n2)*(n3))=reshape(outwt,(/(n1)*(n2)*(n3)/))
  ww((n1)*(n2)*(n3)+1:(n1)*(n2)*(n3)*2)=reshape(outwt,(/(n1)*(n2)*(n3)/))
  ww((n1)*(n2)*(n3)*2+1:(n1)*(n2)*(n3)*3)=reshape(outwt,(/(n1)*(n2)*(n3)/))
  ! deallocate(ww_3D)

  !do it=1,n3

  allocate( rt( n1*n2*n3*3))

 ! call sep_read (data_in)

  ! BREAK INPUT CUBE INTO X DIP DIRECTION AND Y DIP DIRECTIONS
 
  !write(0,*) maxval(px),minval(px),sum(px)/size(px)
  rt=0.
  hh=0.

  rt=0.

  rt(n1*n2*n3+1:2*n1*n2*n3)=reshape(px,(/size(px)/))
  rt(2*n1*n2*n3+1:3*n1*n2*n3)=reshape(py,(/size(py)/))


  call fault_w_init(ww)
  call igrad2_init(n1,n2)
  write(0,*) 'n1,n2,n3',n1,n2,n3
  call igrad3_epst_init(n1,n2,n3,eps_t)
  call dot_test (igrad3_epst_lop,n1*n2*n3,n1*n2*n3*3,dot1,dot2)

  write(0,*) 'initiallized igrad3_epst'
  !method=1
  select case(method)
  case(0)


  case(3)
     k=1
     na=20
     epsi=.1
     !  eps_t=0.
     !   aa = lapfac2(epsi,n1,na) ! REMOVED
     write(0,*) 'about to factor laplacian' 
     aa = lapfac3d(epsi,n1,n2,na,eps_t) ! REMOVED
     write(0,*) 'factored laplacian' 
     call polydiv_init(n1*n2*n3,aa) ! REMOVED

     allocate(tau(n1*n2*n3,k),res_out(niter))
niter=85
     write(0,*) 'beginning solver   niter:',niter
    ! call solver_prc(tau(:,k), rt,igrad3_epst_lop,polydiv_lop,cgstep_wrt,n1*n2*n3,niter,0.,Wop=fault_w_oper,verb=.true.,err=res_out)
    !  call solver_smp(tau(:,k), rt,igrad3_epst_lop,cgstep,30,Wop=fault_w_oper,verb=.true.)
   ! call solver_smp(tau(:,k), rt,igrad3_epst_lop,cgstep,niter,verb=.true.)
  call solver_prc(tau(:,k), rt,igrad3_epst_lop,polydiv_lop,cgstep_wrt,n1*n2*n3,niter,0.,verb=.true.,err=res_out)
    call cgstep_wrt_close ()
  case(4)  ! 

     k=1
     na=10
     epsi=.1 
     aa = lapfac2(epsi,n1,na) ! REMOVED
     call polydiv_init(n1*n2,aa) ! REMOVED

     allocate(tau(n1*n2,k),tmp3(n1*n2), rt_adj(n1*n2*n3),rt_wt(size(rt)))
     stat1=fault_w_oper(.false.,.false.,rt , rt_wt)
     stat1=igrad2_lop(.true.,.false.,rt_adj , rt)
     stat1=polydiv_lop(.false.,.false.,rt_adj,tmp3)
     stat1=polydiv_lop(.true.,.false.,tau(:,k),tmp3)
  case(5) 
     k=1
     na=20
     epsi=.1
     !  eps_t=0.
     !   aa = lapfac2(epsi,n1,na) ! REMOVED
     write(0,*) 'about to factor laplacian' 
     aa = lapfac3d(epsi,n1,n2,na,eps_t) ! REMOVED
     write(0,*) 'factored laplacian' 
     call polydiv_init(n1*n2*n3,aa) ! REMOVED

     allocate(tau(n1*n2*n3,k))
     write(0,*) 'beginning solver'
     call solver_prc(tau(:,k), rt,igrad2_lop,polydiv_lop,cgstep_wrt,n1*n2*n3,niter,0.,Wop=fault_w_oper,verb=.true.)
     ! call solver_smp(tau(:,k), rt,igrad3_epst_lop,cgstep,30,Wop=fault_w_oper,verb=.true.)
     call cgstep_wrt_close ()

  end select

  allocate(tau_3d(n1,n2,n3))
  tau_3d=reshape(tau(:,k),(/n1,n2,n3/))
!!$  do it=1, 256
!!$     tau_3d(it,:,:)=reshape(tau(:,k),(/n1,n2/))
!!$     ! tau_3d(it,:,:)=reshape(z(:,k-1),(/n1,n2/))
!!$  end do


  call sep_write (tau_3d) 
  call to_history ("n1",   n1)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  call to_history ("esize",4)
  ! calculate W(Grad m - p) for res_out(1) 
  allocate(rd_jes(size(rt)),err_out(niter+1))
  !call chain0(Wop,igrad3_epst_lop,F,F,g,gd,tm,td)
  stat1=fault_w_oper(.false.,.false.,-rt,rd_jes)
  err_out(  1) = dot_product(rd_jes,rd_jes)
  err_out(2:niter+1)=res_out
  call sep_write(err_out,"res_out")	
  call to_history("n1",niter+1,"res_out")
  call sep_close()
  call exit (0)


end program Precon_3D











