program Xcorr_tau !
  ! cross correlate  consecutive lines of a flattened tau field
  !
  use sep
  use lint1
  use lint1_jesse
  use sorting_mod

  implicit none
  integer 	                          :: n1, n2, n3, i1,i2,i3,stat1,diff,ip,it,data_out_index,subsam, shift_floor, shift_ceil, useinwt,n1_long,min_shift,counter,max_shift
  integer ::mm_min, mm_max, mm_sz,n1_aux,n1_out,ref_2,ref_3
  integer :: is_allocate
  real :: d1,d2,d3,o1,o2,o3,o1_aux
  real,   dimension(:,:), allocatable,target    :: shifted_outputs,out
  real,    dimension (:,:,:),   allocatable :: data_in,data_out,time_cube,outwt,inwt
  real, save, pointer, dimension(:)         ::lint_in, lint_out,shift_vec,shifted_test
  real,dimension(:),allocatable         ::mm_interp
  real, save, dimension(:),pointer                        ::coord
  real                                      ::shift_var,iprl, diffrl,shift_diff,upwt,dwnwt,max_move,min_move,range_move
  logical :: flatten
  call sep_init ()
  call from_history (n1,n2,n3, esize = 4)
 
  call to_history ("esize",4)

  call from_history ("d1",d1,1.) ; call from_history ("o1",o1,0.)
  call from_history ("d2",d2,1.) ; call from_history ("o2",o2,0.)
  call from_history ("d3",d3,1.) ; call from_history ("o3",o3,0.)






  allocate (data_in (n1,n2,1),out(n1,n2))  !,inwt(n1,n2,n3)                                ! read data

  ! ; data = data / maxval (cabs (data)) ! normalize
  ! inwt=0.
  !  if (useinwt==0.) then
  !   inwt=1.
  !  else 
  !    call sreed("inwt", inwt,4*n1*n2*n3)

  !  endif



  write(0,*) 'n1/n2/n3',n1,n2,n3
  call sreed("in", data_in,4*n1*n2*n3)

out=0.
  !do i2=1,n2
     do i1=2,n1      
        out(i1,1:)=sum(data_in(i1,1:,1)*data_in(i1-1,1:,1))
     end do
 ! end do


  call to_history ("n1",   n1)
  call to_history ("n2",n2) 
 call to_history ("o2",o2) 
 call to_history ("d2",d2) 
 call to_history ("n3",1) 

  call sep_write(out)	



  call sep_close()
  call exit (0)
end program Stack_jml














