program Pick_first_break
  !Input fatten_bound and it will track the inner and outer boundaries  Jesse Lomask 10/04/05
  !Store the x, y, norm, distance
  use sep
  use sorting_mod

  implicit none

  integer				::nt, nx, ny, non_zero_mask,istatus,bnd_index
  integer				::it,ix,iy,ir,iq,iz,ip,it_shft,ix_shft,iy_shft
  integer                               ::radius,irx,irt,med_win,cross_win,max_lag,ilag
  integer                               ::diag_count, adj_count, ix_diag, it_diag, ix_new, it_new
  integer                               ::ix_old, it_old,pick_count,which_bound
  real::o1,o2,o3,d1,d2,d3,maxdat,mindat,rangedat,cutoff,dist
  real, pointer, dimension(:,:)	        ::horizon_out,mask_out
  real,  allocatable,dimension(:)        ::picks,picks_med,med_array,base_array,comp_array
  real,  allocatable,dimension(:,:)        ::dip_out,data
  real, pointer, dimension(:,:)  	::norm_d,mask_in,inner_bnd,outer_bnd
  real                                  ::mask_val1,mask_val2,xcorr,max_xcorr,dip,max_dip
!!$  real, dimension(:,:,:)                ::box_grid,box_grid_colx,box_grid_coly,box_grid_row,box_grid_bnds


  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)

!!$  ! INPUT PARAMETERS
  call from_history("n1",nt); call from_history("n2",nx);
  call from_history("n3",ny);
  call from_history("o1",o1); call from_history("o2",o2); call from_history("o3",o3);
  call from_history("d1",d1); call from_history("d2",d2); call from_history("d3",d3);

  call from_param("cutoff",cutoff,0.)
  call from_param("med_win",med_win,1)
  call from_param("cross_win",cross_win,150)
  call from_param("max_lag",max_lag,15)
  call from_param("which_bound",which_bound,0)


  ! ALLOCATE INPUT DATA AND MASK
  allocate(data(nt,nx),dip_out(nt,nx))

  ! READ INPUT DATA
  call sep_read(data)

  ! READ IN INPUT MASK
  ! mask_in=1.
  ! if (exist_file("mask_in")) call sreed("mask_in", mask_in, 4*nt*nx) 

  write(0,*) maxval(data),minval(data),nt,nx,ny
  !normalize data
  data=data/maxval(data)
  write(0,*) 'making mask'
  !mask_out=0.
  !  cutoff=.00065
  allocate(base_array(2*cross_win+1),comp_array(2*cross_win+1))
  write(0,*) 'max_lag',max_lag,'cross_win',cross_win,'nt',nt,cross_win+1+max_lag,nt-cross_win-max_lag
  dip_out=0.

  find_bound: do ix=1,nx-1
     do it=cross_win+1+max_lag,nt-cross_win-max_lag
        !write(0,*) 'here'
        base_array=data(it-cross_win:it+cross_win,ix)
        dip=-max_lag
        max_dip=dip
        max_xcorr=-10.
        loop_over_comp_array: do ilag=it-max_lag, it+max_lag

           comp_array=data(ilag-cross_win:ilag+cross_win,ix+1)
           !          write(0,*) base_array
           !          write(0,*) comp_array

           xcorr=dot_product(base_array,comp_array)/dot_product(base_array,base_array)
           !         write(0,*) 'xcorr',xcorr
           !stop
           if (ilag==it-max_lag) then 
              max_xcorr=xcorr
           elseif (xcorr>max_xcorr) then
              max_xcorr=xcorr
              max_dip=dip
           end if
           !          dip_out(it,ix)=dip
           !write(0,*) dip

           dip=dip+1
        end do loop_over_comp_array
       ! if (max_xcorr<.1) then
 ! if (abs(dot_product(base_array,base_array))<.4) then
  !         dip_out(it,ix)=0.
  !      else
           dip_out(it,ix)=max_dip
  !      end if
        !    write(0,*) max_dip

     end do
  end do find_bound





  call to_history("n1",nt) ; call to_history("n2",nx) 
  call to_history("n3",ny)
  call to_history("d1",d1); call to_history("d2",d2)
  call to_history("d3",d3)
  call to_history("o1",o1); call to_history("o2",o2)
  call to_history("o3",o3)
  call to_history("esize",4)
  call sep_write(dip_out)
!!$
!!$     call to_history("n1",nx,"picks.H")
!!$     call to_history("esize",4,"picks.H")
!!$     call sep_write(picks,"picks.H")



end program Pick_first_break

